/***************************** Header files *****************************/

/*

  In theApp::InitInstance,
  should not Screen.create
  and should end with 
        glutMainLoop ();
        return FALSE;

  */

    #define GLUT_DISABLE_ATEXIT_HACK
    #include <Glut.h>

    typedef char IDirectDrawSurface;
    typedef int  LPDIRECTDRAW;
    typedef int  DDBLTFX;
    typedef int  DDSURFACEDESC;

    extern void __cdecl GlutKey     (unsigned char, int, int);
    extern void __cdecl GlutSKey    (int, int, int);
    extern void __cdecl GlutMouse   (int, int);
    extern void __cdecl GlutClick   (int, int, int, int);
    extern void __cdecl GlutDraw    (void);
    extern void __cdecl GlutSuspend (int);
    extern void __cdecl GlutIdle    (void);



/**************************** Alpha blitting ****************************/

static void FlipFX (unsigned x1, unsigned y1, CRect rect) {
    CPoint psp;
    if (vsync) lpDD->WaitForVerticalBlank (DDWAITVB_BLOCKBEGIN, NULL);
    if (fullscreen) {
        lpDDSPrimary->BltFast (x1, y1, buffer, rect, DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
    } else {
        psp.x = 0;
        psp.y = 0;
        ClientToScreen (&psp);
        psp.x += x1;
        psp.y = psp.y + 1 + y1;
        lpDDSPrimary->BltFast (psp.x, psp.y, buffer, rect, DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
    }
}

static void FlipFadeOld (void) {
    unsigned i, c, d;
    unsigned fx [30] = { 60, 0,20,80,40,60, 0,60, 0,60,20,20,80, 0,40, 0,40,20,80,40,20,60, 0,80,40,},
             fy [30] = { 40, 0,60,40,40,80,60, 0,20,60,80,40,80,80, 0,40,80,20, 0,60, 0,20,80,60,20,};
    switch (random (7)) {
        case 0: for (i=0; i<=winysize / 2; i += 2)
                    FlipFX (0, (winysize/2) - i,
                    CRect (0, (winysize/2) - i, winxsize, (winysize/2) + i));
                break;
        case 1: for (i=0; i<=winxsize / 2; i += 3)
                    FlipFX ((winxsize/2) - i, 0,
                    CRect ((winxsize/2) - i, 0, (winxsize/2) + i, winysize));
                break;
        case 2: for (i=0; i<=winysize / 2; i += 2)
                    FlipFX ((winxsize/2) - ((i*3)/2), (winysize/2) - i,
                    CRect ((winxsize/2) - ((i*3)/2), (winysize/2) - i,
                        (winxsize/2) + ((i*3)/2), (winysize/2) + i));
                break;
        case 3: for (i=0; i<=winysize; i += 4)
                    FlipFX (0, 0, CRect (0, winysize - i, winxsize, winysize));
                break;
        case 4: for (i=0; i<=winysize; i += 4)
                    FlipFX (0, winysize - i, CRect (0, 0, winxsize, i));
                break;
        case 5: for (i=0; i<=winxsize; i += 5)
                    FlipFX (0, 0, CRect (winxsize - i, 0, winxsize, winysize));
                break;
        case 6: for (i=0; i<=winxsize; i += 5)
                    FlipFX (winxsize - i, 0, CRect (0, 0, i, winysize));
                break;
        case 7: for (i=0; i<25; i++) {
                    for (c=0; c<winxsize; c+=100) for (d=0; d<winysize; d+=100) {
                        lpDDSPrimary->BltFast (c + fx[i], d + fy[i], buffer, 
                            CRect (c + fx[i], d + fy[i], c + fx[i] + 20, d + fy[i] + 20),
                            DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
                        }
                        if (vsync) lpDD->WaitForVerticalBlank (DDWAITVB_BLOCKBEGIN, NULL);
                    }
                break;
    }
}

static void ColorFade (void) {
    unsigned c, d;
    if (gamma == NULL) {
        Flip ();
        return;
    }
    for (c=255; c>=0; c--) {
        for (d=0; d<256-c; d++) {
            gammaramp.red   [d] = 0;
            gammaramp.green [d] = 0;
            gammaramp.blue  [d] = 0;
        }
        for (; d<256; d++) {
            gammaramp.red   [d] = 256 + d - c;
            gammaramp.green [d] = 256 + d - c;
            gammaramp.blue  [d] = 256 + d - c;
        }
        gamma->SetGammaRamp (0, &gammaramp);
    }
    Flip ();
    for (c=0; c<256; c++) {
        for (d=0; d<256-c; d++) {
            gammaramp.red   [d] = 0;
            gammaramp.green [d] = 0;
            gammaramp.blue  [d] = 0;
        }
        for (; d<256; d++) {
            gammaramp.red   [d] = 256 + d - c;
            gammaramp.green [d] = 256 + d - c;
            gammaramp.blue  [d] = 256 + d - c;
        }
        gamma->SetGammaRamp (0, &gammaramp);
    }
}

static void Alph_Fade (void) {
    static unsigned fadelevel = 0;
    unsigned i;
    if (fade) {
        if (fade == 1) {
            //fadebuf->surface->BltFast (0, 0, buffer,       NULL, DDBLTFAST_NOCOLORKEY  | DDBLTFAST_WAIT);
            buffer->BltFast           (0, 0, lpDDSPrimary, NULL, DDBLTFAST_NOCOLORKEY  | DDBLTFAST_WAIT);
            fade = 2;
            fadelevel = 8;
        } else {
            //LockDual (fadebuf, back);
            short *sp = (short*) ddsd2.lpSurface,
                  *dp = (short*) ddsd .lpSurface;
            unsigned mask [8] = { 0x8410, 0x8410, 0xc618, 0xc618, 0xe79c, 0xe79c, 0xf7de, 0xf7de },
                     mask1[8];
            for (i=0; i<10; i++) mask1[i] = 0xffff ^ mask[i];

            for (i=0; i<winxsize * winysize; i++) {
                *dp = ((*dp) & mask[fadelevel]) | ((*sp) & mask1[fadelevel]);
                /*
                unsigned r, g, b;
                r = (*sp) & 0xf800;
                g = (*sp) & 0x07e0;
                b = (*sp) & 0x001f;
                r = ((r * (31 - fadelevel)) / 32) & 0xf800;
                g = ((g * (31 - fadelevel)) / 32) & 0x07e0;
                b = ((b * (31 - fadelevel)) / 32) & 0x001f;
                *dp = r | g | b;*/
                /* *dp = (((*dp) * fadelevel) + (*sp)) / fadelevel + 1; */
                *dp++;
                *sp++;
            }
            Unlock ();
        }
        fadelevel--;
        if (fadelevel == 0) fade = 0;
    }
}

void CScreen::BlitFade (int tx, int ty, int sx, int sy, int ax, int ay, int alph) {
    int i, j;
    if (this      == NULL) return;
    if (locksurf  == NULL) return;
    if (locksurf2 == NULL) return;
    short *sp = ((short*) ddsd2.lpSurface) + sx + (ddsd2.lPitch * sy),
          *dp = ((short*) ddsd .lpSurface) + tx + (ddsd .lPitch * ty);
    for (j=ay; j>0; j--) {
        for (i=ax; i>0; i--) {
            *dp = (((*sp) * alph) + ((*dp) * (63 - alph))) / 64;
            *dp++;
            *sp++;
        }
        *dp += ddsd. lPitch - ax;
        *sp += ddsd2.lPitch - ax;
    }
}

void CScreen::BlitFadeTr (int tx, int ty, int sx, int sy, int ax, int ay, int alph) {
    int i, j;
    if (this      == NULL) return;
    if (locksurf  == NULL) return;
    if (locksurf2 == NULL) return;
    short *sp = ((short*) ddsd2.lpSurface) + sx + (ddsd2.lPitch * sy),
          *dp = ((short*) ddsd .lpSurface) + tx + (ddsd .lPitch * ty);
    for (j=ay; j>0; j--) {
        for (i=ax; i>0; i--) {
            if ((*sp) != 0)
                *dp = (((*sp) * alph) + ((*dp) * (63 - alph))) / 64;
            *dp++;
            *sp++;
        }
        *dp += ddsd. lPitch - ax;
        *sp += ddsd2.lPitch - ax;
    }
}



/**************************** Glut redirects ****************************/

#define TexCoords(x,y) glTexCoord2f ((float)(x) / (float)(xsize), (float)(y) / (float)(ysize))

void inline CScreen::Pset (unsigned x, unsigned y, COLORREF color) {
    unsigned char *c = (unsigned char*) &color;
    glColor3b (c[2] / 2, c[1] / 2, c[0] / 2);
    glVertex2i (x, y);
}

void inline CSprite::Blit (int tx, int ty, int sx, int sy, int ax, int ay) {
    if (1) {
        glBindTexture (GL_TEXTURE_2D, image);
    } else {
        glCallList (image);
    }
    glBegin (GL_QUADS);
    TexCoords  (sx,      sy);
    glVertex2i (tx,      ty);
    TexCoords  (sx + ax, sy);
    glVertex2i (tx + ax, ty);
    TexCoords  (sx + ax, sy + ay);
    glVertex2i (tx + ax, ty + ay);
    TexCoords  (sx,      sy + ay);
    glVertex2i (tx,      ty + ay);
    glEnd ();
}

void inline CSprite::BlitTr (int tx, int ty, int sx, int sy, int ax, int ay) {
    if (1) {
        glBindTexture (GL_TEXTURE_2D, image);
    } else {
        glCallList (image);
    }
    glBegin (GL_QUADS);
    TexCoords  (sx,      sy);
    glVertex2i (tx,      ty);
    TexCoords  (sx + ax, sy);
    glVertex2i (tx + ax, ty);
    TexCoords  (sx + ax, sy + ay);
    glVertex2i (tx + ax, ty + ay);
    TexCoords  (sx,      sy + ay);
    glVertex2i (tx,      ty + ay);
    glEnd ();
}

void CSprite::Stretch (int tx, int ty, int ax, int ay, int sx, int sy, int ex, int ey) {
    if (1) {
        glBindTexture (GL_TEXTURE_2D, image);
    } else {
        glCallList (image);
    }
    glBegin (GL_QUADS);
    TexCoords  (sx,      sy);
    glVertex2i (tx,      ty);
    TexCoords  (sx + ex, sy);
    glVertex2i (tx + ax, ty);
    TexCoords  (sx + ex, sy + ey);
    glVertex2i (tx + ax, ty + ay);
    TexCoords  (sx,      sy + ey);
    glVertex2i (tx,      ty + ay);
    glEnd ();
}

void CSprite::StretchTr (int tx, int ty, int ax, int ay, int sx, int sy, int ex, int ey) {
    if (1) {
        glBindTexture (GL_TEXTURE_2D, image);
    } else {
        glCallList (image);
    }
    glBegin (GL_QUADS);
    TexCoords  (sx,      sy);
    glVertex2i (tx,      ty);
    TexCoords  (sx + ex, sy);
    glVertex2i (tx + ax, ty);
    TexCoords  (sx + ex, sy + ey);
    glVertex2i (tx + ax, ty + ay);
    TexCoords  (sx,      sy + ey);
    glVertex2i (tx,      ty + ay);
    glEnd ();
}

static void __cdecl GlutKey (unsigned char key, int, int) {
    if (key >= 'a' && key <= 'z') key += 'A' - 'a';
    theApp.HandleKeyPress (key, glutGetModifiers ());
}

static void __cdecl GlutSKey (int key, int, int) {
    switch (key) {
        case 0x7f:               key = VK_DELETE; break;
        case GLUT_KEY_F1:        key = VK_F1;     break;
        case GLUT_KEY_F2:        key = VK_F2;     break;
        case GLUT_KEY_F3:        key = VK_F3;     break;
        case GLUT_KEY_F4:        key = VK_F4;     break;
        case GLUT_KEY_F5:        key = VK_F5;     break;
        case GLUT_KEY_F6:        key = VK_F6;     break;
        case GLUT_KEY_F7:        key = VK_F7;     break;
        case GLUT_KEY_F8:        key = VK_F8;     break;
        case GLUT_KEY_F9:        key = VK_F9;     break;
        case GLUT_KEY_F10:       key = VK_F10;    break;
        case GLUT_KEY_F11:       key = VK_F11;    break;
        case GLUT_KEY_F12:       key = VK_F2;     break;
        case GLUT_KEY_LEFT:      key = VK_LEFT;   break;
        case GLUT_KEY_UP:        key = VK_UP;     break;
        case GLUT_KEY_RIGHT:     key = VK_RIGHT;  break;
        case GLUT_KEY_DOWN:      key = VK_DOWN;   break;
        case GLUT_KEY_PAGE_UP:   key = VK_PRIOR;  break;
        case GLUT_KEY_PAGE_DOWN: key = VK_NEXT;   break;
        case GLUT_KEY_HOME:      key = VK_HOME;   break;
        case GLUT_KEY_END:       key = VK_END;    break;
        case GLUT_KEY_INSERT:    key = VK_INSERT; break;
    }
    theApp.HandleKeyPress (key, glutGetModifiers ());
}

static void __cdecl GlutMouse (int x, int y) {
    GlutClick (0, 0, x, y);
}

static void __cdecl GlutClick (int button, int state, int x, int y) {
    static unsigned lmouse = 0;
    unsigned b1;
    theApp.HandleMouseMove (x, y, glutGetModifiers ());
    if (state == GLUT_DOWN) switch (button) {
        case GLUT_LEFT_BUTTON:   lmouse = Key_MouseL;
                                 b1 = VE_LeftClick;  break;
        case GLUT_RIGHT_BUTTON:  b1 = VE_RightClick; break;
        case GLUT_MIDDLE_BUTTON: b1 = VE_LeftDouble; break;
    } else {
        if (button == GLUT_LEFT_BUTTON) lmouse = 0;
    }
    theApp.HandleMouseClick (b1, glutGetModifiers () | lmouse);
}

static void __cdecl GlutSuspend (int vis) {
    if (vis == GLUT_VISIBLE) theApp.Suspend (false);
    else                     theApp.Suspend (true);
}

static void __cdecl GlutIdle (void) {
    if (theApp.runlevel == Run_Normal || theApp.runlevel = Run_Title) {
        glutPostRedisplay ();
    } else if (theApp.runlevel != Run_Suspend && theApp.runlevel != Run_TitleSuspend) {
        /* Copy from regular exit routine */
        theApp.HandleExit ();
        exit (0);
    }
}

static void __cdecl GlutDraw (void) {
    /* Copy speed routine from theApp::Run () */
    glClear           (GL_COLOR_BUFFER_BIT);
    theApp.HandleTick ();
    theApp.HandleDraw ();
    if (glGetError ()) theApp.runlevel = Run_ScreenError;
}
