// transparency doesn't work, nor blitfade
// Glut keys return ascii codes rather than scancodes
// maybe screen update should be done by glut_idle or glut_timer

#include "Common\StdAfx.h"
#include "Compress.h"
#include "Graphics.h"
#include "Kernel.h"
#include "..\Strings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#ifdef USE_GLUT

bool CScreen::Init (unsigned boff) {
    int  argc    = 1;
    char *argv[] = { " ", " " },
         *exten,
         *version;
    if (BaseInit (boff) == false) return false;

    glutInit            (&argc, argv);
    glutInitDisplayMode (GLUT_RGB | GLUT_DOUBLE);
    glutInitWindowSize  (winxsize, winysize);
    glutCreateWindow    (AppName);

    exten   = (char*) glGetString (GL_EXTENSIONS);
    version = (char*) glGetString (GL_VERSION);
    // string!
    if (strstr (exten, "GL_EXT_texture_object") == 0 && strncmp(version, "1.1", 3) != 0)
        return false;

    // this is not right, with the jpegs
    jpegbuf = sprlist.AddToList (NULL);
    jpegbuf->Create       (winxsize, winysize, NULL);
    glutSetCursor         (GLUT_CURSOR_NONE);
    glutKeyboardFunc      (GlutKey);
    glutMotionFunc        (GlutMouse);
    glutPassiveMotionFunc (GlutMouse);
    glutMouseFunc         (GlutClick);
    glutSpecialFunc       (GlutSKey);
    glutDisplayFunc       (GlutDraw);
    glutVisibilityFunc    (GlutSuspend);
    glutIdleFunc          (GlutIdle);
    glViewport            (0, 0, winxsize, winysize);
    gluOrtho2D            (0, winxsize, winysize, 0);
    glMatrixMode          (GL_MODELVIEW);
    glDisable             (GL_DITHER);
    glDisable             (GL_DEPTH_TEST);
    glDisable             (GL_LIGHTING);
    glEnable              (GL_ALPHA_TEST);
    glEnable              (GL_TEXTURE_2D);
    glTexEnvi             (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
    glHint                (GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
    glHint                (GL_POINT_SMOOTH_HINT,           GL_FASTEST);
    glHint                (GL_LINE_SMOOTH_HINT,            GL_FASTEST);
    glHint                (GL_POLYGON_SMOOTH_HINT,         GL_FASTEST);
    glHint                (GL_FOG_HINT,                    GL_FASTEST);
    glutFullScreen        ();
    return true;
}

void CScreen::Destroy (void) {
    sprlist.~CSprite ();
    jpeg_destroy_decompress (&cinfo);
}

bool CScreen::Restore (void) {
    return true;
}

bool CScreen::CreateSurface (unsigned xsize, unsigned ysize, IDirectDrawSurface** surface) {
    return true;
}



/************************************ Graphical functions ************************************/

void CScreen::Flip (void) {
    glutSwapBuffers ();
}

void CScreen::FlipCopy (void) {
}

void CScreen::FlipFX (unsigned x1, unsigned y1, CRect rect) {
}

void CScreen::FlipFade (void) {
}

void CScreen::Lock (CSprite* spr) {
    if (locksurf == NULL) {
        locksurf = (char*) 1;
        glBegin (GL_POINTS);
    }
}

void CScreen::LockDual (CSprite* spr) {
}

void CScreen::Unlock (void) {
    locksurf = NULL;
    glEnd ();
}

void CScreen::PutLine (unsigned x1, unsigned y1, unsigned x2, unsigned y2, COLORREF color) {
    unsigned char *c = (unsigned char*) &color;
    glColor3b (c[2] / 2, c[1] / 2, c[0] / 2);
    if (x1 >= winxsize || x2 >= winxsize || y1 >= winysize || y2 >= winysize) return;
    glBegin    (GL_LINE);
    glVertex2i (x1, y1);
    glVertex2i (x2, y2);
    glEnd      ();
}

void CScreen::PutRect (unsigned x1, unsigned y1, unsigned x2, unsigned y2, COLORREF color) {
    unsigned char *c =  (unsigned char*) &color;
    glColor3b    (c[2] / 2, c[1] / 2, c[0] / 2);
    glBegin      (GL_QUADS);
    glVertex2i   (x1, y1);
    glVertex2i   (x2, y1);
    glVertex2i   (x2, y2);
    glVertex2i   (x1, y2);
    glEnd        ();
}

void CScreen::PutEdge (unsigned x1, unsigned y1, unsigned x2, unsigned y2, COLORREF color) {
    unsigned char *c = (unsigned char*) &color;
    glColor3b (c[2] / 2, c[1] / 2, c[0] / 2);
    if (x1 > winxsize) x1 = -1; else if (x2 > winxsize) x2 = winxsize;
    if (y1 > winysize) y1 = -1; else if (y2 > winysize) y2 = winysize;
    glBegin    (GL_LINE_LOOP);
    glVertex2i (x1, y1);
    glVertex2i (x2, y1);
    glVertex2i (x2, y2);
    glVertex2i (x1, y2);
    glEnd      ();
}

void CScreen::BlitFade (int tx, int ty, int sx, int sy, int ax, int ay, int alpha) {
}

void CScreen::BlitFadeTr (int tx, int ty, int sx, int sy, int ax, int ay, int alpha) {
}

char* CScreen::DXError (HRESULT hErr) {
    return " \n\0";
}



/***************************** Sprite class *****************************/

CSprite::~CSprite (void) {
    if (next) {
        delete next;
        next = NULL;
    }
    if (surface) {
        delete surface;
        surface = NULL;
    }
}

bool CSprite::Load (void) {
    char     tag   [4],
             c;
    unsigned size,
             offs,
             truex,
             truey,
             i;
    FILE     *file;

    if (surface != NULL) {
        delete surface;
        surface = NULL;
    }
    if (theApp.MediaLib) {
        // check mediaref validity
        fseek (theApp.MediaLib, MediaRef[Screen.offset_bmp + image], SEEK_SET);
        fread (&truex, 4, 1, theApp.MediaLib);
        fread (&truey, 4, 1, theApp.MediaLib);
        surface = pack.ExpandToRam (theApp.MediaLib);
        if (ferror (theApp.MediaLib)) {
            theApp.runlevel = Run_FileError;
            return false;
        }
        if (surface == NULL) {
            theApp.runlevel = Run_MemError;
            return false;
        }
    } else {
        // readbufferpure?
        file = fopen (StrTable[Str_Bitmaps + image], "rb");
        fseek (file,   2, SEEK_SET); /* id 'BM'     */
        fread (&size,  4, 1, file);  /* size        */
        fseek (file,   4, SEEK_CUR); /* reserved    */
        fread (&offs,  4, 1, file);  /* offset      */
        fseek (file,   4, SEEK_CUR); /* size again  */
        fread (&truex, 4, 1, file);  /* width       */
        fread (&truey, 4, 1, file);  /* height      */
        fseek (file,   2, SEEK_CUR); /* planes      */
        fread (tag,    2, 1, file);  /* bits/pixel  */
        if (tag[0] != 24) {
            TRACE1 ("Bitmap %s should have 24-bit colors.\n", StrTable[Str_Bitmaps + image]);
            theApp.runlevel = Run_FileError;
            return false;
        }
        fread (tag,    4, 1, file);  /* compression */
        if (tag[0]) {
            TRACE1 ("Bitmap %s is compressed (possibly RLE)\n", StrTable[Str_Bitmaps + image]);
            theApp.runlevel = Run_FileError;
            return false;
        }
        fseek (file, offs, SEEK_SET);
        for (xsize = 0x8000; xsize >= truex; xsize /= 2); xsize *= 2;
        for (ysize = 0x8000; ysize >= truey; ysize /= 2); ysize *= 2;
        size -= offs;
        // more mallocs
        surface = (char*) malloc (xsize * ysize * 3);
        if (surface == NULL) {
            theApp.runlevel = Run_MemError;
            return false;
        }
        for (i=truey - 1; i != -1; i--) {
            fread (surface + (xsize * 3 * i), truex * 3, 1, file);
        }
        if (ferror (file)) {
            theApp.runlevel = Run_FileError;
            return false;
        }
        fclose (file);
    }
    for (i=0; i<size; i += 3) {
        c              = surface[i];
        surface[i]     = surface[i + 2];
        surface[i + 2] = c;
    }

    if (1) {
        glGenTextures (1, &image);
        glBindTexture (GL_TEXTURE_2D, image);
    } else {
        image = glGenLists (1);
        glNewList (image, GL_COMPILE);
    }
    glTexImage2D    (GL_TEXTURE_2D, 0, 3, xsize, ysize, 0, GL_RGB, GL_UNSIGNED_BYTE, surface);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    if (1) {
    } else {
        glEndList ();
    }
    return true;
}

#endif
