/* Gamma and DX7 have been stubbed out */
/* PutCircle could use some optimizing */

// some nonessential comments about anims

#include "Common/StdAfx.h"
#include "Compress.h"
#include "Graphics.h"
#include "Kernel.h"
#include "../Strings.h"

#undef TRIAL_MODE // screenshots, which don't work, and framerate


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
static void jpeg_destroy_decompress (void*)             {}
static void jpeg_stdio_src          (void*, void*)      {}
static void jpeg_read_header        (void*, int)        {}
static void jpeg_start_decompress   (void*)             {}
static void jpeg_read_scanlines     (void*, void*, int) {}
static void jpeg_finish_decompress  (void*)             {}
static void jpeg_create_decompress  (void*)             {}
static j_common_ptr jpeg_std_error  (void*)  { return 0; }
void        error_hook              (void) { /* Screen.Unlock (); */ ((char*) 0)[1] = 1; }
#endif

CScreen    Screen;
CAnimation Anims [MAX_ANITYPE];



/***************************** Generic functions *****************************/

CScreen::CScreen (void) {
    unsigned i;
    memset (&ddsd,  0, sizeof (DDSURFACEDESC));
    memset (&ddsd2, 0, sizeof (DDSURFACEDESC));
    memset (&bltfx, 0, sizeof (DDBLTFX));
    int fontinit [] = {
         0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, /* Low ascii   */
         0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
         9,  7,  8, 15, 11, 16, 16,  4,  7,  8,  8, 11,  4,  9,  4, 10, /* Gothic font */
        11,  8, 10, 10, 11, 11, 10, 11, 10, 10,  4,  4,  8,  9,  8,  8,
         0, 14, 15, 14, 14, 15, 14, 14, 15,  9, 14, 16, 15, 17, 16, 14,
        14, 15, 17, 15, 16, 17, 13, 17, 15, 14, 12,  9, 10,  9, 16,  9,
        17,  9,  9,  8,  9,  9,  7, 10,  9,  6,  5, 10,  5, 14, 12,  8,
        10,  9, 10, 11,  7, 12, 10, 14, 11, 10,  8, 14,  0, 14, 18, 18,
         5,  3,  4,  9,  9, 10, 10,  2,  5,  5,  7,  9,  4,  7,  4,  7, /* Times font  */
         9,  7,  8,  8,  8,  8,  8,  9,  8,  8,  4,  4,  9,  9,  9,  6,
         0, 10,  8,  8,  9,  8,  8,  9, 10,  6,  7,  9,  8, 12, 10,  9,
         8,  9,  9,  7,  8, 10, 10, 12,  9, 10,  8,  5,  7,  4,  9,  9,
         7,  7,  8,  7,  8,  7,  6,  7,  8,  4,  4,  8,  4, 12,  8,  8,
         8,  8,  6,  6,  5,  8,  8, 10,  8,  8,  6,  6,  4,  6,  8, 18 };
    winxsize     = 0;
    winysize     = 0;
    mousex       = 100;
    mousey       = 100;
    animstate    = 0;
    offset_bmp   = 0;
    offset_spr   = 0;
    offset_jpeg  = 0;
    hires        = true;
    fade         = false;
    usewindow    = true;
    doflip       = true;
    lpDD         = NULL;
    lpDDSPrimary = NULL;
    buffer       = NULL;
    font         = NULL;
    locksurf     = NULL;
    locksurf2    = NULL;
    m_hIcon      = NULL;
    memcpy (fontdata, fontinit, sizeof (fontinit));
    for (i=0; i<MAX_JBUF; i++) jpeg_cache [i] = 0xfffe;
    #ifdef _DEBUG
        fullscreen = false;
    #else
        fullscreen = true;
    #endif
}

METHODDEF(void) my_error_exit (j_common_ptr cinfo) {
    my_error_mgr* myerr = (my_error_mgr*) cinfo->err;
    char errorbuffer [JMSG_LENGTH_MAX];
    (*cinfo->err->format_message) (cinfo, errorbuffer);
    theApp.runlevel = Run_MemError;
    longjmp (myerr->setjmp_buffer, 1);
}

bool CScreen::BaseInit (unsigned boff, unsigned soff, unsigned joff, unsigned jmax) {
    if (hires) winxsize = 1024;
    else       winxsize =  800;
    winysize    = (winxsize * 3) / 4;
    cinfo.err   = jpeg_std_error (&jerr.pub);
    offset_bmp  = boff;
    offset_spr  = soff;
    offset_jpeg = joff;
    last_jpeg   = jmax;
    jerr.pub.error_exit = my_error_exit;

    /* Interaction between '_setjmp' and C++ object destruction is non-portable */
    #ifndef LINUX
    #pragma warning(disable:4611)
    #endif
    if (setjmp (jerr.setjmp_buffer)) return false;

    jpeg_create_decompress (&cinfo);
    jpeg = jpegbuf[0];
    return true;
}

unsigned CScreen::TextWidth (const char *str, bool font) {
    unsigned x = 0, i = 0;
    if (str == NULL) return 0;
    while (str[i] == 0x0a) i++;
    while (str[i] > 0x0a) {
        if (str[i] == '@') break;
        if (str[i] != '$') x += fontdata[str[i] + (font ? 96 : 0)];
        i++;
    }
    return x;
}

void CScreen::PutTextBox (int x1, int y1, int x2, unsigned flags, unsigned num) {
    PutTextBox (x1, y1, x2, flags, MkStr (num));
}

void CScreen::PutTextBox (int x1, int y1, int x2, unsigned flags, const char *str) {
    int      x,
             y = y1;
    unsigned i = 0,
             j,
             c,
             d1, d2,
             uline,
             f1 = 1;

    if (str == NULL || font == NULL) return;
    while (str[i] == 0x0a) i++;
    if (flags & Txt_AltFont) {
        while (str[i]) {
            x     = x1;
            j     = i - 1;
            c     = str[i];
            d1    = 0;
            d2    = 0;
            uline = flags & Txt_Underline;
            if (c == '$') {
                i++;
                j++;
                uline = true;
            }
            while (c > 0x0a && c != '@') {
                j++;
                c = str [j];
                if (c != '_') {
                    if (c >= 0x20) c += 96;
                    x += fontdata [c];
                }
                if (x >= x2) {
                    if ((flags & Txt_WordBreak) == 0) break;
                    for (c=0; c<j; c++) {
                        if (str[c] == ' ') break;
                    }
                    if (c == j) break;
                    c = str[j];
                    while (1) {
                        x -= fontdata [c + 96];
                        if (c == ' ') break;
                        j--;
                        c = str [j];
                    }
                    f1 = 0;
                    break;
                }
                if (flags & Txt_Border)
                    if (j > 0 && str[j - 1] == '.' && str[j] == ' ') break;
            }
            if (flags & Txt_Center) {
                x -= 2; x = x2 - x; x >>= 1; x += x1;
            } else if (flags & Txt_Right) {
                x -= 2; x -= x1; x = x2 - x;
            } else if ((flags & Txt_Justify) && c == ' ') {
                d1 = x2 - x;
                d2 = 0;
                for (c=i; c<j; c++) if (str[c] == ' ') d2 ++;
                x = x1;
            } else x = x1;
            if (flags & Txt_Border) {
                if (x >= 71)
                     font->BlitTr (x - 71, y - 5, 470,          184, 71, 28);
                else font->BlitTr (0,      y - 5, 470 + 71 - x, 184, x,  28);
                for (; i<j; i++) {
                    c = str [i] + 96;
                    font->BlitTr (x, y - 5, 470 + 61, 184,            fontdata[c],     28);
                    font->BlitTr (x, y, 20 * (c & 15), 15 * (c / 16), fontdata[c] + 1, 15);
                    x += fontdata [c];
                    if (d2 && c == ' ' + 96) x += d1 / d2;
                }
                if (x + 72 < (signed) winxsize)
                     font->BlitTr (x, y - 5, 470 + 71, 184, 72,           28);
                else font->BlitTr (x, y - 5, 470 + 71, 184, winxsize - x, 28);
                break;
            } else {
                if (uline) for (; i<j; i++) {
                    c = str [i] + 96;
                    font->BlitTr (x, y, 20 * (c   & 15),     15 * (c   / 16), fontdata[c] + 1, 15);
                    font->BlitTr (x, y, 20 * (191 & 15) + 1, 15 * (191 / 16), fontdata[c] + 1, 15);
                    x += fontdata [c];
                    if (d2 && c == ' ' + 96) x += d1 / d2;
                } else for (; i<j; i++) {
                    c = str [i] + 96;
                    font->BlitTr (x, y, 20 * (c & 15), 15 * (c / 16), fontdata[c] + 1, 15);
                    x += fontdata [c];
                    if (d2 && c == ' ' + 96) x += d1 / d2;
                }
            }
            y += 16;
            c = str[i];
            if ((flags & Txt_WordBreak) == 0) while (c != 0x0a && c != 0 && c != '@') {
                 i++; c = str [i];
            }
            if (c != 0) i++;
        }
    } else {
        while (str[i]) {
            x     = x1;
            j     = i - 1;
            c     = str[i];
            d1    = 0;
            d2    = 0;
            uline = flags & Txt_Underline;
            if (c == '$') {
                i++;
                j++;
                uline = true;
            }
            while (c > 0x0a && c != '@') {
                j++;
                c = str [j];
                x += fontdata [c];
                if (x >= x2) {
                    if ((flags & Txt_WordBreak) == 0) break;
                    for (c=0; c<j; c++) {
                        if (str[c] == ' ') break;
                    }
                    if (c == j) break;
                    c = str[j];
                    while (1) {
                        x -= fontdata [c];
                        if (c == ' ') break;
                        j--;
                        c = str [j];
                    }
                    if (f1) {
                        y -= 11;
                        f1 = 0;
                    }
                    break;
                }
                if (flags & Txt_Border)
                    if (j > 0 && str[j - 1] == '.') break;
            }
            if (flags & Txt_Center) {
                x -= 2; x = x2 - x; x >>= 1; x += x1;
            } else if (flags & Txt_Right) {
                x -= 2; x -= x1; x = x2 - x;
            } else if ((flags & Txt_Justify) && c == ' ') {
                d1 = x2 - x;
                d2 = 0;
                for (c=i; c<j; c++) if (str[c] == ' ') d2 ++;
                x = x1;
            } else x = x1;
            if (flags & Txt_Border) {
                if (x >= 71)
                     font->BlitTr (x - 71, y - 5, 470,          184, 71, 28);
                else font->BlitTr (0,      y - 5, 470 + 71 - x, 184, x,  28);
                for (; i<j; i++) {
                    c = str [i];
                    font->BlitTr (x, y - 5, 470 + 61, 184,                 fontdata[c], 28);
                    font->BlitTr (x, y, 20 * (c & 15), 20 * (c / 16) - 40, fontdata[c] + 1, 20);
                    x += fontdata [c];
                    if (d2 && c == ' ') x += d1 / d2;
                }
                if (x + 72 < (signed) winxsize)
                     font->BlitTr (x, y - 5, 470 + 71, 184, 72,           28);
                else font->BlitTr (x, y - 5, 470 + 71, 184, winxsize - x, 28);
            } else {
                if (flags & Txt_Hashed) for (; i<j; i++) {
                    c = str [i];
                    font->BlitTr (x, y, 20 * (c   & 15), 20 * (c   / 16) - 40, fontdata[c] + 1, 20);
                    font->BlitTr (x, y, 20 * (124 & 15), 20 * (124 / 16) - 40, fontdata[c] + 1, 20);
                    x += fontdata [c];
                    if (d2 && c == ' ') x += d1 / d2;
                } else for (; i<j; i++) {
                    c = str [i];
                    font->BlitTr (x, y, 20 * (c & 15), 20 * (c / 16) - 40, fontdata[c] + 1, 20);
                    x += fontdata [c];
                    if (d2 && c == ' ') x += d1 / d2;
                }
            }
            y += 22;
            c = str[i];
            if ((flags & Txt_WordBreak) == 0) while (c != 0x0a && c != 0 && c != '@') {
                 i++; c = str [i];
            }
            if (c != 0) i++;
        }
    }
}

/*
#if defined (_DEBUG) || defined (TRIAL_MODE)
void CScreen::SaveBitmap (CSprite *spr, const char *fname) {
    unsigned i, x, y;
    short    j;
    FILE     *file;
    file = fopen (fname, "wb");
    if (file) {
        fputc ('B', file);
        fputc ('M', file);
        i = spr->xsize * spr->ysize * 3 + 54; fwrite (&i, 4, 1, file);
        i = 0;                                fwrite (&i, 4, 1, file);
        i = 54;                               fwrite (&i, 4, 1, file);
        i = 40;                               fwrite (&i, 4, 1, file);
        i = spr->xsize;                       fwrite (&i, 4, 1, file);
        i = spr->ysize;                       fwrite (&i, 4, 1, file);
        j = 1;                                fwrite (&j, 2, 1, file);
        j = 24;                               fwrite (&j, 2, 1, file);
        i = 0;                                fwrite (&i, 4, 1, file);
        i = spr->xsize * spr->ysize * 3;      fwrite (&i, 4, 1, file);
        i = 3790;                             fwrite (&i, 4, 1, file);
        i = 3780;                             fwrite (&i, 4, 1, file);
        i = 0;                                fwrite (&i, 4, 1, file);
        i = 0;                                fwrite (&i, 4, 1, file);
        if (spr->surface) {
            theApp.DebugMessage (spr->xsize);
            theApp.DebugMessage (spr->ysize);
            Lock (spr);
            if (winbpp == 2) {
                for (y=spr->ysize; y>0; y--) for (x=0; x<spr->xsize; x++) {
                    i = Pget_16 (x, y-1);
                    i = ((i & 0xf800) << 8) | ((i & 0x07e0) << 5) | ((i & 0x001f) << 3);
                    fwrite (&i, 3, 1, file);
                }
            } else {
                for (y=spr->ysize; y>0; y--) for (x=0; x<spr->xsize; x++) {
                    i = Pget_32 (x, y-1);
                    i = ((i & 0xf800) << 8) | ((i & 0x07e0) << 5) | ((i & 0x001f) << 3);
                    fwrite (&i, 3, 1, file);
                }
            }
            Unlock ();
        } else if (spr->bmpbuf) {
            fwrite (spr->bmpbuf, spr->xsize * spr->ysize, 3, file);
        }
        fclose (file);
    }
}
#else
void CScreen::SaveBitmap (CSprite*, const char*) {}
#endif
*/

void CScreen::SaveScreenshot (void) {
    #ifdef TRIAL_MODE
        unsigned count = 0;
        char     buf [32];
        FILE     *file;
        while (1) {
            sprintf (buf, "Screen%d.bmp", count);
            file = fopen (buf, "rb");
            if (file == NULL) break;
            fclose (file);
            count ++;
        }
        SaveBitmap (back, buf);
    #endif
}

static bool PurgeAnims (void);



/***************************** DirectX specific ******************************/

#ifndef USE_ALLEGRO
#ifndef LINUX

bool CScreen::Init (unsigned boff, unsigned soff, unsigned joff, unsigned jmax) {
    DDCOLORKEY ddck;
    HRESULT    r;
    CRect      rect;
    unsigned   i;

    ddsd. dwSize = sizeof (DDSURFACEDESC);
    ddsd2.dwSize = sizeof (DDSURFACEDESC);
    bltfx.dwSize = sizeof (DDBLTFX);
    bltfx.dwROP  = BLACKNESS;
    videomem     = 0;
    winbpp       = 2;
    ddck.dwColorSpaceHighValue = 0;
    ddck.dwColorSpaceLowValue  = 0;
    theApp.DebugMessage ("Base graphics");
    if (BaseInit (boff, soff, joff, jmax) == false) return false;

    theApp.DebugMessage ("DDInit ()");
    if (lpDD == NULL) {
        /* r = DirectDrawCreateEx (NULL, (void**) &lpDD, IID_IDirectDraw7, NULL); */
        r = DirectDrawCreate (NULL, &lpDD, NULL);
        if (FAILED (r)) {
            theApp.DebugMessage ("DDInit ()", true);
            theApp.DebugMessage (DXError (r), true);
            return false;
        }
    }
    if (fullscreen) {
        r = lpDD->SetCooperativeLevel (GetSafeHwnd (), DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN /*| DDSCL_ALLOWREBOOT*/ /*| DDSCL_NOWINDOWCHANGES*/);
    } else {
        SetWindowPos (NULL, 0, 0, winxsize+7, winysize+33, SWP_SHOWWINDOW);
        r = lpDD->SetCooperativeLevel (GetSafeHwnd (), DDSCL_NORMAL);
    }
    if (FAILED (r)) {
        theApp.DebugMessage ("Exclusive display access");
        theApp.DebugMessage (DXError (r), true);
        return false;
    }
    GetWindowRect (&rect);
    ValidateRect  (&rect);
    if (fullscreen) {
        r = lpDD->SetDisplayMode (winxsize, winysize, 16);
        if (FAILED (r) && hires) {
            theApp.DebugMessage ("High resolution fails, attempting low...", true);
            hires = false;
            winxsize = 800;
            winysize = 600;
            r = lpDD->SetDisplayMode (winxsize, winysize, 16);
        }
        if (FAILED (r)) {
            theApp.DebugMessage ("Changing display mode", true);
            theApp.DebugMessage (DXError (r), true);
            return false;
        }
    }

    theApp.DebugMessage ("Primary screen buffer");
    if (lpDDSPrimary == NULL) {
        memset (&ddsd, 0, sizeof (DDSURFACEDESC));
        ddsd.dwSize         = sizeof (DDSURFACEDESC);
        ddsd.dwFlags        = DDSD_CAPS;
        ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
        if (fullscreen) {
            ddsd.dwFlags           |= DDSD_BACKBUFFERCOUNT;
            ddsd.ddsCaps.dwCaps    |= DDSCAPS_FLIP | DDSCAPS_COMPLEX;
            ddsd.dwBackBufferCount  = 1;
        } else {
            ddsd.dwHeight           = winxsize;
            ddsd.dwWidth            = winysize;
        }
        r = lpDD->CreateSurface (&ddsd, &lpDDSPrimary, NULL);
        if (FAILED (r)) {
            theApp.DebugMessage ("Primary screen buffer", true);
            theApp.DebugMessage (DXError (r), true);
            return false;
        }
        videomem += winxsize * winysize * 2;
        lpDDSPrimary->SetColorKey (DDCKEY_DESTBLT, &ddck);
        if (fullscreen) {
            lpDDSPrimary->Blt (CRect (0, 0, winxsize, winysize), NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
        } else {
            while (1) {
                if (usewindow) {
                    r = lpDDSPrimary->Blt (CRect (3, 23, winxsize+3, winysize+23), NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
                } else {
                    r = lpDDSPrimary->Blt (CRect (0, 0, winxsize, winysize), NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
                }
                if (FAILED (r)) {
                    if (usewindow) {
                        usewindow = false;
                    } else if (hires == false) {
                        theApp.DebugMessage ("Screen blanking", true);
                        theApp.DebugMessage (DXError (r), true);
                        return false;
                    } else {
                        hires     = false;
                        usewindow = true;
                        winxsize  = 800;
                        winysize  = 600;
                        ddsd.dwHeight = winxsize;
                        ddsd.dwWidth  = winysize;
                        SetWindowPos (NULL, 0, 0, winxsize+7, winysize+27, SWP_SHOWWINDOW);
                        lpDDSPrimary->Release ();
                        r = lpDD->CreateSurface (&ddsd, &lpDDSPrimary, NULL);
                        if (FAILED (r)) {
                            theApp.DebugMessage ("High resolution fails, attempting low...", true);
                            theApp.DebugMessage (DXError (r), true);
                            return false;
                        }
                        lpDDSPrimary->SetColorKey (DDCKEY_DESTBLT, &ddck);
                    }
                } else break;
            }
        }
        front = sprlist.AddToList (lpDDSPrimary);
    }

    theApp.DebugMessage ("Secondary screen buffer");
    if (buffer == NULL) {
        if (fullscreen) {
            ddsd.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER;
            r = lpDDSPrimary->GetAttachedSurface (&ddsd.ddsCaps, &buffer);
        } else {
            ddsd.dwWidth        = winxsize;
            ddsd.dwHeight       = winysize;
            ddsd.dwFlags        = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
            ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
            r = lpDD->CreateSurface (&ddsd, &buffer, NULL);
            videomem += winxsize * winysize * 2;
        }
        if (FAILED (r)) {
            theApp.DebugMessage ("Secondary screen buffer", true);
            theApp.DebugMessage (DXError (r), true);
            return false;
        }
        ddck.dwColorSpaceLowValue  = 0;
        ddck.dwColorSpaceHighValue = 0;
        buffer->SetColorKey (DDCKEY_DESTBLT, &ddck);
        buffer->Blt (CRect (0, 0, winxsize, winysize), NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
        back = sprlist.AddToList (buffer);
    }
    jpegbuf[0] = sprlist.AddToList (NULL);
    jpegbuf[0]->Create (winxsize, winysize, NULL, true);
    for (i=1; i<MAX_JBUF; i++) {
        jpegbuf[i] = sprlist.AddToList (NULL);
        jpegbuf[i]->Create (winxsize, winysize, NULL, false);
    }

    /*
    theApp.DebugMessage ("Gamma");
    r = lpDD->QueryInterface (IID_IDirectDrawGammaControl, (void**) &gamma);
    if (FAILED (r)) {
        theApp.DebugMessage ("Gamma controls", true);
        theApp.DebugMessage (DXError (r), true);
    }
    */
    memset (&gammaramp, 0, sizeof (gammaramp));

    ShowCursor (false);
    return true;
}

void CScreen::Destroy (void) {
    CSprite *spr = sprlist.next,
            *s1;
    #ifndef NO_ANIM
        CAnimList *tmp, *t2;
        for (tmp = animlist;  tmp != NULL; tmp = t2) {
            t2 = tmp->next;
            delete tmp;
        }
        for (tmp = junkfirst; tmp != NULL; tmp = t2) {
            t2 = tmp->next;
            delete tmp;
        }
        animlist  = NULL;
        junkfirst = NULL;
        junklast  = NULL;
    #endif
    while (spr) {
        s1 = spr->next;
        spr->Destroy ();
        delete spr;
        spr = s1;
    }
    sprlist.Destroy ();
    if (nextsprite) {
        do {
            nextsprite--;
            animsprites[nextsprite].Destroy ();
        } while (nextsprite != 0);
    }
    if (lpDD) {
        lpDD->RestoreDisplayMode ();
        lpDD->Release ();
        lpDD = NULL;
    }
    jpeg_destroy_decompress (&cinfo);
}

bool CScreen::Restore (void) {
    HRESULT  r;
    CSprite  *spr;
    unsigned i, j;
    for (i=0; i<MAX_JBUF; i++) jpeg_cache[i] = 0xfffe;
    if (fullscreen) { // line below is new
        lpDD->SetCooperativeLevel (GetSafeHwnd (), DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN /*| DDSCL_ALLOWREBOOT*/ /*| DDSCL_NOWINDOWCHANGES*/);
        r = lpDD->SetDisplayMode (winxsize, winysize, 16);
        if (FAILED (r)) {
            theApp.DebugMessage ("Restoring display mode", true);
            theApp.DebugMessage (DXError (r), true);
            //return false;
        }
    }
    for (spr = sprlist.next; spr != NULL; spr = spr->next) {
        if (spr->surface == NULL) continue;
        if (spr->surface->IsLost ()) {
            r = spr->surface->Restore ();
            if (FAILED (r) && r != DDERR_IMPLICITLYCREATED) {
                theApp.DebugMessage ("Restoring graphics buffers", true);
                theApp.DebugMessage (DXError (r), true);
                //return false;
            }
            if (spr->image == 0xfffe) {
                spr->Destroy ();
            } else if (spr->Load (StrTable[Str_Bitmaps + spr->image]) == false) {
                //return false;
            }
        }
    }
    for (i=0; i<MAX_ANITYPE; i++) if (Anims[i].loaded) {
        j = Anims[i].refcount;
        Anims[i].refcount = 0;
        PurgeAnims ();
        Anims[i].refcount = j;
        Anims[i].loaded   = false;
    }
    return true;
}

bool CScreen::CreateSurface (unsigned xsize, unsigned ysize, IDirectDrawSurface** surface, bool vidmem) {
    DDCOLORKEY ddck;
    HRESULT    r;
    if (lpDD == NULL) return false;
    memset (&ddsd, 0, sizeof (DDSURFACEDESC));
    ddsd.dwSize   = sizeof (DDSURFACEDESC);
    ddsd.dwFlags  = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.dwWidth  = xsize;
    ddsd.dwHeight = ysize;
    if (vidmem) ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    else        ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
    r = lpDD->CreateSurface (&ddsd, surface, NULL);
    if (FAILED (r)) {
        theApp.DebugMessage ("Creating graphics buffer", true);
        theApp.DebugMessage (DXError (r), true);
        return false;
    }
    ddck.dwColorSpaceLowValue  = 0;
    ddck.dwColorSpaceHighValue = 0;
    (*surface)->SetColorKey (DDCKEY_SRCBLT, &ddck);
    if (vidmem) {
        (*surface)->GetCaps (&ddsd.ddsCaps);
        if (ddsd.ddsCaps.dwCaps & DDSCAPS_SYSTEMMEMORY) {
            theApp.DebugMessage ("(no video memory left, using regular memory)");
        } else if (ddsd.ddsCaps.dwCaps & DDSCAPS_NONLOCALVIDMEM) {
        } else videomem += xsize * ysize * 2;
    }
    return true;
}

void CScreen::WaitVSync (void) {
    lpDD->WaitForVerticalBlank (DDWAITVB_BLOCKBEGIN, NULL);
}

#define winbpp 2

void CScreen::Flip (void) { // something crashes in here
    /*unsigned fx [16] = { 0,1,3,2,1,3,2,0,2,3,1,0,3,2,0,1 },
             fy [16] = { 0,2,1,3,1,0,2,3,0,2,3,1,3,1,2,0 };
    unsigned x0, i, j;*/
    CPoint   psp;

    if (doflip == false) {
        doflip = true;
        return;
    }
    #ifdef TRIAL_MODE
    char buf[16];
    if (theApp.showspeed) {
        if (theApp.speed < 95 || theApp.speed > 105) {
            sprintf (buf, "%d%c", theApp.speed, '%');
            PutRect    (0, winysize - 25, 60, winysize, 0);
            PutTextBox (8, winysize - 25, 60, 0, buf);
        }
    }
    #endif
    if (fullscreen) {
        /*if (fade) {
            LockDual (back, front);
            if (winbpp == 2) {
                for (fade = 2; fade < 19; fade++) {
                    x0 = fx[fade - 2] * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                        PsetXfer2_16 (i, j);
                    if (fullscreen && fade > 2) {
                        x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                        for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                            PsetXfer2_16 (i, j);
                    }
                }
            } else {
                for (fade = 2; fade < 19; fade++) {
                    x0 = fx[fade - 2] * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                        PsetXfer2_32 (i, j);
                    if (fullscreen && fade > 2) {
                        x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                        for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                            PsetXfer2_32 (i, j);
                    }
                }
            }
            Unlock ();
            fade = false;
        } else */{
            if (theApp.detailmode) lpDDSPrimary->Flip (NULL, DDFLIP_WAIT);
            else                   lpDDSPrimary->Flip (NULL, 0);
        }
    } else {
        fade  = false;
        psp.x = 0;
        psp.y = 0;
        if (usewindow) {
            ClientToScreen (&psp);
            psp.y++;
        }
        if (theApp.detailmode) lpDD->WaitForVerticalBlank (DDWAITVB_BLOCKBEGIN, NULL);
        lpDDSPrimary->BltFast (psp.x, psp.y, buffer, CRect (0, 0, winxsize, winysize), DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
    }
}

void CScreen::FlipCopy (void) {
    if (fullscreen) {
        lpDDSPrimary->BltFast (0, 0, buffer, CRect (0, 0, winxsize, winysize), DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
    }
}

void CScreen::Lock (CSprite* spr) {
    if (spr == NULL) return;
    if (locksurf != NULL) Unlock ();
    locksurf = spr->surface;
    if (locksurf != NULL) {
        locksurf->Lock (NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL);
        ddsd.lPitch /= 2;
    }
}

void CScreen::LockDual (CSprite* spr, CSprite* spr2) {
    if (spr == NULL || spr2 == NULL) return;
    if (locksurf != NULL) Unlock ();
    Lock (spr);
    locksurf2 = spr2->surface;
    if (locksurf2 != NULL) {
        locksurf2->Lock (NULL, &ddsd2, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL);
        ddsd2.lPitch /= 2;
    }
}

void CScreen::Unlock (void) {
    if (locksurf != NULL) {
        locksurf->Unlock (ddsd.lpSurface);
        locksurf = NULL;
    }
    if (locksurf2 != NULL) {
        locksurf2->Unlock (ddsd2.lpSurface);
        locksurf2 = NULL;
    }
}

void CScreen::PutRect (unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned color) {
	// this fails somehow in SubTerra; check coords -- crash occurs in flipcode?
	//TRACE2 ("%s %s", x1, y1);
	//TRACE2 ("and %s %s", x2, y2);
    bltfx.dwFillColor = GetColor (color);
    if (DDBLTFAST_WAIT)
         buffer->Blt (CRect (x1, y1, x2, y2), NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
    else buffer->Blt (CRect (x1, y1, x2, y2), NULL, NULL, DDBLT_COLORFILL,              &bltfx);
}

const char* CScreen::DXError (HRESULT hErr) {
    switch (hErr) {
        case DD_OK:
            return "No error.";
        case DDERR_ALREADYINITIALIZED:
            return "This object is already initialized.";
        case DDERR_BLTFASTCANTCLIP:
            return "    return if a clipper object is attached to the source surface passed into a BltFast call.";
        case DDERR_CANNOTATTACHSURFACE:
            return "This surface can not be attached to the requested surface.";
        case DDERR_CANNOTDETACHSURFACE:
            return "This surface can not be detached from the requested surface.";
        case DDERR_CANTCREATEDC:
            return "Windows can not create any more DCs.";
        case DDERR_CANTDUPLICATE:
            return "Can't duplicate primary & 3D surfaces, or surfaces that are implicitly created.";
        case DDERR_CLIPPERISUSINGHWND:
            return "An attempt was made to set a cliplist for a clipper object that is already monitoring an hwnd.";
        case DDERR_COLORKEYNOTSET:
            return "No src color key specified for this operation.";
        case DDERR_CURRENTLYNOTAVAIL:
            return "Support is currently not available.";
        case DDERR_DIRECTDRAWALREADYCREATED:
            return "A DirectDraw object representing this driver has already been created for this process.";
        case DDERR_EXCEPTION:
            return "An exception was encountered while performing the requested operation.";
        case DDERR_EXCLUSIVEMODEALREADYSET:
            return "An attempt was made to set the cooperative level when it was already set to exclusive.";
        case DDERR_GENERIC:
            return "Generic failure. That wasn't really helpful now was it? Blame Bill for it.";
        case DDERR_HEIGHTALIGN:
            return "Height of rectangle provided is not a multiple of reqd alignment.";
        case DDERR_HWNDALREADYSET:
            return "The CooperativeLevel HWND has already been set. It can not be reset while the process has surfaces or palettes created.";
        case DDERR_HWNDSUBCLASSED:
            return "HWND used by DirectDraw CooperativeLevel has been subclassed, this prevents DirectDraw from restoring state.";
        case DDERR_IMPLICITLYCREATED:
            return "This surface can not be restored because it is an implicitly created surface.";
        case DDERR_INCOMPATIBLEPRIMARY:
            return "Unable to match primary surface creation request with existing primary surface.";
        case DDERR_INVALIDCAPS:
            return "One or more of the caps bits passed to the callback are incorrect.";
        case DDERR_INVALIDCLIPLIST:
            return "DirectDraw does not support the provided cliplist.";
        case DDERR_INVALIDDIRECTDRAWGUID:
            return "The GUID passed to DirectDrawCreate is not a valid DirectDraw driver identifier.";
        case DDERR_INVALIDMODE:
            return "Mode not supported.\nApparently some other program is using the graphics drivers.\nTry closing other applications and try again, or if that fails,\nreboot and try again.\nAlso, do not run Leylines from a command prompt window.";
        case DDERR_INVALIDOBJECT:
            return "DirectDraw received a pointer that was an invalid DIRECTDRAW object.";
        case DDERR_INVALIDPARAMS:
            return "One or more of the parameters passed to the function are incorrect. (for instance, image width greater than screen width)";
        case DDERR_INVALIDPIXELFORMAT:
            return "The pixel format was invalid as specified.";
        case DDERR_INVALIDPOSITION:
            return "    returned when the position of the overlay on the destination is no longer legal for that destination.";
        case DDERR_INVALIDRECT:
            return "Rectangle provided was invalid.";
        case DDERR_LOCKEDSURFACES:
            return "Operation could not be carried out because one or more surfaces are locked.";
        case DDERR_NO3D:
            return "There is no 3D present.";
        case MAKE_DDHRESULT (180):
            return "Operation could not be carried out because there is no al" "pha accleration hardware present or available.";
        case DDERR_NOBLTHW:
            return "No blitter hardware present.";
        case DDERR_NOCLIPLIST:
            return "No cliplist available.";
        case DDERR_NOCLIPPERATTACHED:
            return "No clipper object attached to surface object.";
        case DDERR_NOCOLORCONVHW:
            return "Operation could not be carried out because there is no color conversion hardware present or available.";
        case DDERR_NOCOLORKEY:
            return "Surface doesn't currently have a color key";
        case DDERR_NOCOLORKEYHW:
            return "Operation could not be carried out because there is no hardware support of the destination color key.";
        case DDERR_NOCOOPERATIVELEVELSET:
            return "Create function called without DirectDraw object method SetCooperativeLevel being called.";
        case DDERR_NODC:
            return "No DC was ever created for this surface.";
        case DDERR_NODDROPSHW:
            return "No DirectDraw ROP hardware.";
        case DDERR_NODIRECTDRAWHW:
            return "A hardware-only DirectDraw object creation was attempted but the driver did not support any hardware.";
        case DDERR_NOEMULATION:
            return "Software emulation not available.";
        case DDERR_NOEXCLUSIVEMODE:
            return "Operation requires the application to have exclusive mode but the application does not have exclusive mode.";
        case DDERR_NOFLIPHW:
            return "Flipping visible surfaces is not supported.";
        case DDERR_NOGDI:
            return "There is no GDI present.";
        case DDERR_NOHWND:
            return "Clipper notification requires an HWND or no HWND has previously been set as the CooperativeLevel HWND.";
        case DDERR_NOMIRRORHW:
            return "Operation could not be carried out because there is no hardware present or available.";
        case DDERR_NOOVERLAYDEST:
            return "    returned when GetOverlayPosition is called on an overlay that UpdateOverlay has never been called on to establish a destination.";
        case DDERR_NOOVERLAYHW:
            return "Operation could not be carried out because there is no overlay hardware present or available.";
        case DDERR_NOPALETTEATTACHED:
            return "No palette object attached to this surface.";
        case DDERR_NOPALETTEHW:
            return "No hardware support for 16 or 256 color palettes.";
        case DDERR_NORASTEROPHW:
            return "Operation could not be carried out because there is no appropriate raster op hardware present or available.";
        case DDERR_NOROTATIONHW:
            return "Operation could not be carried out because there is no rotation hardware present or available.";
        case DDERR_NOSTRETCHHW:
            return "Operation could not be carried out because there is no hardware support for stretching.";
        case DDERR_NOT4BITCOLOR:
            return "DirectDrawSurface is not in 4 bit color palette and the requested operation requires 4 bit color palette.";
        case DDERR_NOT4BITCOLORINDEX:
            return "DirectDrawSurface is not in 4 bit color index palette and the requested operation requires 4 bit color index palette.";
        case DDERR_NOT8BITCOLOR:
            return "DirectDrawSurface is not in 8 bit color mode and the requested operation requires 8 bit color.";
        case DDERR_NOTAOVERLAYSURFACE:
            return "    returned when an overlay member is called for a non-overlay surface.";
        case DDERR_NOTEXTUREHW:
            return "Operation could not be carried out because there is no texture mapping hardware present or available.";
        case DDERR_NOTFLIPPABLE:
            return "An attempt has been made to flip a surface that is not flippable.";
        case DDERR_NOTFOUND:
            return "Requested item was not found.";
        case DDERR_NOTLOCKED:
            return "Surface was not locked.  An attempt to unlock a surface that was not locked at all, or by this process, has been attempted.";
        case DDERR_NOTPALETTIZED:
            return "The surface being used is not a palette-based surface.";
        case DDERR_NOVSYNCHW:
            return "Operation could not be carried out because there is no hardware support for vertical blank synchronized operations.";
        case DDERR_NOZBUFFERHW:
            return "Operation could not be carried out because there is no hardware support for zbuffer blitting.";
        case DDERR_NOZOVERLAYHW:
            return "Overlay surfaces could not be z layered based on their BltOrder because the hardware does not support z layering of overlays.";
        case DDERR_OUTOFCAPS:
            return "The hardware needed for the requested operation has already been allocated.";
        case DDERR_OUTOFMEMORY:
            return "DirectDraw does not have enough memory to perform the operation.";
        case DDERR_OUTOFVIDEOMEMORY:
            return "DirectDraw does not have enough video memory to perform the operation.";
        case DDERR_OVERLAYCANTCLIP:
            return "The hardware does not support clipped overlays.";
        case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:
            return "Can only have ony color key active at one time for overlays.";
        case DDERR_OVERLAYNOTVISIBLE:
            return "    returned when GetOverlayPosition is called on a hidden overlay.";
        case DDERR_PALETTEBUSY:
            return "Access to this palette is being refused because the palette is already locked by another thread.";
        case DDERR_PRIMARYSURFACEALREADYEXISTS:
            return "This process already has created a primary surface.";
        case DDERR_REGIONTOOSMALL:
            return "Region passed to Clipper::GetClipList is too small.";
        case DDERR_SURFACEALREADYATTACHED:
            return "This surface is already attached to the surface it is being attached to.";
        case DDERR_SURFACEALREADYDEPENDENT:
            return "This surface is already a dependency of the surface it is being made a dependency of.";
        case DDERR_SURFACEBUSY:
            return "Access to this surface is being refused because the surface is already locked by another thread.";
        case DDERR_SURFACEISOBSCURED:
            return "Access to surface refused because the surface is obscured.";
        case DDERR_SURFACELOST:
            return "Access to this surface is being refused because the surface memory is gone. The DirectDrawSurface object representing this surface should have Restore called on it.";
        case DDERR_SURFACENOTATTACHED:
            return "The requested surface is not attached.";
        case DDERR_TOOBIGHEIGHT:
            return "Height requested by DirectDraw is too large.";
        case DDERR_TOOBIGSIZE:
            return "Size requested by DirectDraw is too large, but the individual height and width are OK.";
        case DDERR_TOOBIGWIDTH:
            return "Width requested by DirectDraw is too large.";
        case DDERR_UNSUPPORTED:
            return "Action not supported.";
        case DDERR_UNSUPPORTEDFORMAT:
            return "FOURCC format requested is unsupported by DirectDraw.";
        case DDERR_UNSUPPORTEDMASK:
            return "Bitmask in the pixel format requested is unsupported by DirectDraw.";
        case DDERR_VERTICALBLANKINPROGRESS:
            return "Vertical blank is in progress.";
        case DDERR_WASSTILLDRAWING:
            return "Informs DirectDraw that the previous Blt which is transfering information to or from this Surface is incomplete.";
        case DDERR_WRONGMODE:
            return "This surface can not be restored because it was created in a different mode.";
        case DDERR_XALIGN:
            return "Rectangle provided was not horizontally aligned on required boundary.";
        default:
            return "Unrecognized error value.";
    }
}



/********************************* L i n u x *********************************/

#else

bool CScreen::Init (unsigned boff, unsigned soff, unsigned joff, unsigned jmax) {
    unsigned i;
    theApp.DebugMessage ("Base graphics");
    if (BaseInit (boff, soff, joff, jmax) == false) return false;

    theApp.DebugMessage ("Creating window");
    i = SDL_HWSURFACE | SDL_DOUBLEBUF;
    if (fullscreen) i |= SDL_FULLSCREEN;
    screen = SDL_SetVideoMode (winxsize, winysize, 0, i);
    if (screen == NULL) {
        theApp.DebugMessage ("Creating window", true);
        theApp.DebugMessage (DXError (0), true);
        return false;
    }
    winbpp = screen->format->BitsPerPixel / 8;
    if (winbpp != 2 && winbpp != 4) {
        theApp.DebugMessage ("Invalid color resolution: only 16 or 32 bits per pixel are supported.", true);
        return false;
    }
    back     = sprlist.AddToList (screen);
    fadebuf  = sprlist.AddToList (NULL);
    fadebuf->Create (winxsize, winysize, NULL, false);
    videomem = 3 * screen->format->BytesPerPixel * winxsize * winysize;
    for (i=0; i<MAX_JBUF; i++) {
        jpegbuf[i] = sprlist.AddToList (NULL);
        jpegbuf[i]->Create (winxsize, winysize, NULL, false);
    }
    SDL_ShowCursor (0);
    return true;
}

void CScreen::Destroy (void) {
    CSprite *spr = sprlist.next,
            *s1;
    while (spr) {
        s1 = spr->next;
        spr->Destroy ();
        delete spr;
        spr = s1;
    }
    sprlist.Destroy ();
    if (nextsprite) {
        do {
            nextsprite--;
            animsprites[nextsprite].Destroy ();
        } while (nextsprite != 0);
    }
    if (lpDD) {
        lpDD->RestoreDisplayMode ();
        lpDD->Release ();
        lpDD = NULL;
    }
    jpeg_destroy_decompress (&cinfo);
    jpeg_destroy_decompress (&cinfo);
}

bool CScreen::Restore (void) {
    unsigned i, j;
    for (i=0; i<MAX_JBUF; i++) jpeg_cache[i] = 0xfffe;
    for (i=0; i<MAX_ANITYPE; i++) if (Anims[i].loaded) {
        j = Anims[i].refcount;
        Anims[i].refcount = 0;
        PurgeAnims ();
        Anims[i].refcount = j;
        Anims[i].loaded   = false;
    }
    return true;
}

bool CScreen::CreateSurface (unsigned xsize, unsigned ysize, SDL_Surface** surface, bool vidmem) {
    *surface = SDL_CreateRGBSurface ((vidmem ? SDL_HWSURFACE : 0), 
                                     xsize, ysize,
                                     screen->format->BitsPerPixel,
                                     screen->format->Rmask,
                                     screen->format->Gmask,
                                     screen->format->Bmask,
                                     screen->format->Amask);
    if (*surface == NULL) {
        theApp.DebugMessage ("Creating graphics buffer", true);
        theApp.DebugMessage (DXError (0), true);
        return false;
    }
    return true;
}

void CScreen::WaitVSync (void) {}

void CScreen::FlipCopy (void) {
    back->BlitTo (0, 0, 0, 0, winxsize, winysize, fadebuf);
    SDL_Flip (screen);
}

void CScreen::Flip (void) {
    unsigned fx [16] = { 0,1,3,2,1,3,2,0,2,3,1,0,3,2,0,1 },
             fy [16] = { 0,2,1,3,1,0,2,3,0,2,3,1,3,1,2,0 };
    unsigned x0, i, j;

    if (doflip == false) {
        doflip = true;
        return;
    }
    if (theApp.showspeed) {
        PutRect    (0, winysize - 25, 80, winysize, 0);
        PutTextBox (8, winysize - 25, 80, 0, MkStr (theApp.speed));
    }
    if (fade) {
        SDL_BlitSurface (screen, 0, fadebuf->surface, 0);
        SDL_FillRect    (screen, 0, 0);
        SDL_Flip        (screen);
        SDL_FillRect    (screen, 0, 0);

        for (fade = 2; fade < 19; fade++) {
            LockDual (fadebuf, back);
            x0 = fx[fade - 2] * 2;
            if (winbpp == 2) {
                for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                    PsetXfer2_16 (i, j);
                if (fade > 2) {
                    x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                        PsetXfer2_16 (i, j);
                }
        } else {
                for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                    PsetXfer2_32 (i, j);
                if (fade > 2) {
                    x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                        PsetXfer2_32 (i, j);
                }
            }
            Unlock   ();
            SDL_Flip (screen);
        }
        fade = 0;
        return;
    }
    SDL_Flip (screen);
}

void CScreen::Lock (CSprite* spr) {
    if (spr == NULL) return;
    if (locksurf != NULL) Unlock ();
    locksurf = spr->surface;
    if (locksurf != NULL) {
        SDL_LockSurface (locksurf);
    }
}

void CScreen::LockDual (CSprite* spr, CSprite* spr2) {
    if (spr == NULL || spr2 == NULL) return;
    if (locksurf != NULL || locksurf2 != NULL) Unlock ();

    locksurf = spr->surface;
    if (locksurf != NULL) {
        SDL_LockSurface (locksurf);
    }
    locksurf2 = spr2->surface;
    if (locksurf2 != NULL) {
        SDL_LockSurface (locksurf2);
    }
}

void CScreen::Unlock (void) {
    if (locksurf != NULL) {
        SDL_UnlockSurface (locksurf);
        locksurf = NULL;
    }
    if (locksurf2 != NULL) {
        SDL_UnlockSurface (locksurf2);
        locksurf2 = NULL;
    }
}

void CScreen::PutRect (unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned color) {
    Uint32 color32 = SDL_MapRGB (screen->format,
                                 (color & 0xff0000) >> 16,
                                 (color & 0x00ff00) >> 8,
                                  color & 0x0000ff);
    SDL_Rect r = { x1, y1, x2 - x1, y2 - y1 };
    SDL_FillRect (screen, &r, color32);
}

const char* CScreen::DXError (HRESULT hErr) {
    return SDL_GetError ();
}

#endif
#else


/******************************* A l l e g r o *******************************/

bool CScreen::Init (unsigned boff, unsigned soff, unsigned joff, unsigned jmax) {
    unsigned i;
    theApp.DebugMessage ("Base graphics");
    if (BaseInit (boff, soff, joff, jmax) == false) return false;

    theApp.DebugMessage ("Creating window");
    i = GFX_AUTODETECT;
    #ifdef _DEBUG
    i = GFX_AUTODETECT_WINDOWED;
    #endif

    set_color_depth (16);
    if (set_gfx_mode (i, 800, 600, 0, 0) != 0) {
        theApp.DebugMessage ("Creating window error", true);
        theApp.DebugMessage (DXError (0), true);
        return false;
    }
    
    // screen = auto.set, rmv from .h?
    //winbpp = bitmap_color_depth(screen) / 8;  ==null by now
    /*if (winbpp != 2 && winbpp != 4) {
        theApp.DebugMessage ("Invalid color resolution: only 16 or 32 bits per pixel are supported.", true);
        return false;
    }*/
    lpDDSPrimary = create_video_bitmap (SCREEN_W, SCREEN_H);
    buffer       = create_video_bitmap (SCREEN_W, SCREEN_H);

    back     = sprlist.AddToList (lpDDSPrimary);
    /*fadebuf  = sprlist.AddToList (NULL);
    fadebuf->Create (winxsize, winysize, NULL, false);*/
    for (i=0; i<MAX_JBUF; i++) {
        jpegbuf[i] = sprlist.AddToList (NULL);
        jpegbuf[i]->Create (winxsize, winysize, NULL, false);
    }
    disable_hardware_cursor ();
    return true;
}

void CScreen::Destroy (void) {
    CSprite *spr = sprlist.next,
            *s1;
    while (spr) {
        s1 = spr->next;
        spr->Destroy ();
        delete spr;
        spr = s1;
    }
    sprlist.Destroy ();
    if (nextsprite) {
        do {
            nextsprite--;
            animsprites[nextsprite].Destroy ();
        } while (nextsprite != 0);
    }
    jpeg_destroy_decompress (&cinfo);
    jpeg_destroy_decompress (&cinfo);
    destroy_bitmap (lpDDSPrimary);
    destroy_bitmap (buffer);
}

bool CScreen::Restore (void) {
    //?
    return true;
}

bool CScreen::CreateSurface (unsigned xsize, unsigned ysize, SDL_Surface** surface, bool) {
    *surface = create_bitmap (xsize, ysize);
    if (*surface == NULL) {
        theApp.DebugMessage ("Creating graphics buffer", true);
        theApp.DebugMessage (DXError (0), true);
        return false;
    }
    return true;
}

void CScreen::WaitVSync (void) {}

void CScreen::FlipCopy (void) {
    back->BlitTo (0, 0, 0, 0, winxsize, winysize, fadebuf);
    //SDL_Flip (screen);
    show_video_bitmap (buffer);
    BITMAP *tmp  = lpDDSPrimary;
    lpDDSPrimary = buffer;
    buffer       = tmp;
}

void CScreen::Flip (void) {
    //unsigned fx [16] = { 0,1,3,2,1,3,2,0,2,3,1,0,3,2,0,1 },
             //fy [16] = { 0,2,1,3,1,0,2,3,0,2,3,1,3,1,2,0 };
    //unsigned x0, i, j;

    if (doflip == false) {
        doflip = true;
        return;
    }
    if (theApp.showspeed) {
        PutRect    (0, winysize - 25, 80, winysize, 0);
        PutTextBox (8, winysize - 25, 80, 0, MkStr (theApp.speed));
    }
    if (fade) {/*
        SDL_BlitSurface (screen, 0, fadebuf->surface, 0);
        SDL_FillRect    (screen, 0, 0);
        SDL_Flip        (screen);
        SDL_FillRect    (screen, 0, 0);

        for (fade = 2; fade < 19; fade++) {
            LockDual (fadebuf, back);
            x0 = fx[fade - 2] * 2;
            if (winbpp == 2) {
                for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                    PsetXfer2_16 (i, j);
                if (fade > 2) {
                    x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                        PsetXfer2_16 (i, j);
                }
        } else {
                for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 2]; j<winysize; j += 4)
                    PsetXfer2_32 (i, j);
                if (fade > 2) {
                    x0 = x0 + (fx[fade - 3] - fx[fade - 2]) * 2;
                    for (i=x0; i<winxsize; i += 8) for (j=fy[fade - 3]; j<winysize; j += 4)
                        PsetXfer2_32 (i, j);
                }
            }
            Unlock   ();
            SDL_Flip (screen);
        }
        fade = 0;
        return;*/
    }
    show_video_bitmap (buffer);
    BITMAP *tmp  = lpDDSPrimary;
    lpDDSPrimary = buffer;
    buffer       = tmp;
}

void CScreen::Lock (CSprite* spr) {
    if (spr == NULL) return;
    if (locksurf != NULL) Unlock ();
    locksurf = spr->surface;
    if (locksurf != NULL)
        acquire_bitmap (locksurf);
}

void CScreen::LockDual (CSprite* spr, CSprite* spr2) {
    if (spr == NULL || spr2 == NULL) return;
    if (locksurf != NULL || locksurf2 != NULL) Unlock ();

    locksurf = spr->surface;
    if (locksurf != NULL)
        acquire_bitmap (locksurf);
    locksurf2 = spr2->surface;
    if (locksurf2 != NULL)
        acquire_bitmap (locksurf2);
}

void CScreen::Unlock (void) {
    if (locksurf != NULL) {
        release_bitmap (locksurf);
        locksurf = NULL;
    }
    if (locksurf2 != NULL) {
        release_bitmap (locksurf2);
        locksurf2 = NULL;
    }
}

const char* CScreen::DXError (HRESULT) {
    return allegro_error;
}

#endif



/******************************* Pixel drawing *******************************/

#ifndef USE_ALLEGRO
void CScreen::PutLine (unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned color) {
    int yDiff = y2 - y1,
        xDiff = x2 - x1,
        error_term = 0,
        length,
        i;
    unsigned j, pos;
    if (locksurf == NULL) error_hook ();
    if (x1 >= winxsize || x2 >= winxsize || y1 >= winysize || y2 >= winysize) { error_hook (); return; }
    color = GetColor (color);
    if (winbpp == 2) {
        if (yDiff == 0) {
            if (x2 < x1) {
                j  = x2;
                x2 = x1;
                x1 = j;
            }
            pos = x1 * StepX_16 () + y1 * StepY ();
            j = x2 - x1 + 1;
            do {
                PMemset_16 (pos, color);
                pos += StepX_16 ();
                j --;
            } while (j);
        } else if (xDiff == 0) {
            if (y2 < y1) {
                j  = y2;
                y2 = y1;
                y1 = j;
            }
            pos = x1 * StepX_16 () + y1 * StepY ();
            j = y2 - y1 + 1;
            do {
                PMemset_16 (pos, color);
                pos += StepY ();
                j --;
            } while (j);
        } else if (yDiff < 0) {
            yDiff = -yDiff;
            if (xDiff < 0) {
                xDiff = -xDiff;
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos -= StepX_16 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos -= StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos -= StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos -= StepX_16 ();
                        }
                    }
                }
            } else {
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos += StepX_16 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos -= StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos -= StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos += StepX_16 ();
                        }
                    }
                }
            }
        } else {
            if (xDiff < 0) {
                xDiff = -xDiff;
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos -= StepX_16 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos += StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos += StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos -= StepX_16 ();
                        }
                    }
                }
            } else {
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos += StepX_16 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos += StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_16 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_16 (pos, color);
                        pos += StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos += StepX_16 ();
                        }
                    }
                }
            }
        }
    } else {
        if (yDiff == 0) {
            if (x2 < x1) {
                j  = x2;
                x2 = x1;
                x1 = j;
            }
            pos = x1 * StepX_32 () + y1 * StepY ();
            j = x2 - x1 + 1;
            do {
                PMemset_32 (pos, color);
                pos += StepX_32 ();
                j --;
            } while (j);
        } else if (xDiff == 0) {
            if (y2 < y1) {
                j  = y2;
                y2 = y1;
                y1 = j;
            }
            pos = x1 * StepX_32 () + y1 * StepY ();
            j = y2 - y1 + 1;
            do {
                PMemset_32 (pos, color);
                pos += StepY ();
                j --;
            } while (j);
        } else if (yDiff < 0) {
            yDiff = -yDiff;
            if (xDiff < 0) {
                xDiff = -xDiff;
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos -= StepX_32 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos -= StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos -= StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos -= StepX_32 ();
                        }
                    }
                }
            } else {
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos += StepX_32 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos -= StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos -= StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos += StepX_32 ();
                        }
                    }
                }
            }
        } else {
            if (xDiff < 0) {
                xDiff = -xDiff;
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos -= StepX_32 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos += StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos += StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos -= StepX_32 ();
                        }
                    }
                }
            } else {
                if (xDiff > yDiff) {
                    length = xDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos += StepX_32 ();
                        error_term += yDiff;
                        if (error_term > xDiff) {
                            error_term -= xDiff;
                            pos += StepY ();
                        }
                    }
                } else {
                    length = yDiff + 1;
                    pos = x1 * StepX_32 () + y1 * StepY ();
                    for (i=0; i<length; i++) {
                        PMemset_32 (pos, color);
                        pos += StepY ();
                        error_term += xDiff;
                        if (error_term > 0) {
                            error_term -= yDiff;
                            pos += StepX_32 ();
                        }
                    }
                }
            }
        }
    }
}

void CScreen::ClipLine (int x1, int y1, int x2, int y2, unsigned color) {
    if (x1 < 0) {
        if (x2 < 0) return;
        x1 = 0;
    } else if (x2 < 0) x2 = 0;
    if (y1 < 0) {
        if (y2 < 0) return;
        y1 = 0;
    } else if (y2 < 0) y2 = 0;
    if (x1 >= (signed) winxsize) {
        if (x2 >= (signed) winxsize) return;
        x1 = winxsize - 1;
    } else if (x2 >= (signed) winxsize) x2 = winxsize - 1;
    if (y1 >= (signed) winysize) {
        if (y2 >= (signed) winysize) return;
        y1 = winysize - 1;
    } else if (y2 >= (signed) winysize) y2 = winysize - 1;
    PutLine (x1, y1, x2, y2, color);
}

void CScreen::PutCircle (unsigned cx, unsigned cy, unsigned cr, unsigned color) {
    int x, y, d;
    if (locksurf == NULL) error_hook ();
    x = 0;
    y = cr;
    d = 1 - cr;
    color = GetColor (color);
    if (winbpp == 2) {
        while (y >= x) {
            PsetClip_16 (cx + x, cy + y, color);
            PsetClip_16 (cx + x, cy - y, color);
            PsetClip_16 (cx - x, cy + y, color);
            PsetClip_16 (cx - x, cy - y, color);
            PsetClip_16 (cx + y, cy + x, color);
            PsetClip_16 (cx + y, cy - x, color);
            PsetClip_16 (cx - y, cy + x, color);
            PsetClip_16 (cx - y, cy - x, color);
            if (d < 0) {
                d += (2 * x) + 3;
            } else {
                d += (2 * (x - y)) + 5;
                y--;
            }
            x++;
        }
    } else {
        while (y >= x) {
            PsetClip_32 (cx + x, cy + y, color);
            PsetClip_32 (cx + x, cy - y, color);
            PsetClip_32 (cx - x, cy + y, color);
            PsetClip_32 (cx - x, cy - y, color);
            PsetClip_32 (cx + y, cy + x, color);
            PsetClip_32 (cx + y, cy - x, color);
            PsetClip_32 (cx - y, cy + x, color);
            PsetClip_32 (cx - y, cy - x, color);
            if (d < 0) {
                d += (2 * x) + 3;
            } else {
                d += (2 * (x - y)) + 5;
                y--;
            }
            x++;
        }
    }
}

void CScreen::PutGray (int x1, int y1, int x2, int y2, unsigned color) {
    unsigned i, j, c1, pos, p1;
    if (locksurf == NULL) error_hook ();
    if (x1 < 0 || x1 >= (signed) winxsize) { error_hook (); return; }
    if (y1 < 0 || y1 >= (signed) winysize) { error_hook (); return; }
    if (x1 > x2 || y1 > y2) error_hook ();
    if (y2 == y1 || x2 - x1 < 4) error_hook ();
    c1 = GetColor (color);
    x1 &= 0xfffe;
    if (winbpp == 2) {
        c1 |= (c1 << 16);
        pos = x1 * StepX_16 () + y1 * StepY ();
        j = y2 - y1;
        do {
            p1 = pos;
            i  = (x2 - x1 + 2) / 4;
            do {
                PMemset2_16 (p1, c1);
                p1 += 4 * StepX_16 ();
                i --;
            } while (i);
            j--;
            if (j == 0) break;
            pos += StepY ();
            p1  = pos + 2 * StepX_16 ();
            i   = (x2 - x1) / 4;
            do {
                PMemset2_16 (p1, c1);
                p1 += 4 * StepX_16 ();
                i --;
            } while (i);
            pos += StepY ();
            j--;
        } while (j);
    } else {
        pos = x1 * StepX_32 () + y1 * StepY ();
        j = y2 - y1;
        do {
            p1 = pos;
            i  = (x2 - x1 + 2) / 4;
            do {
                PMemset_32 (p1, c1);
                p1 += StepX_32 ();
                PMemset_32 (p1, c1);
                p1 += 3 * StepX_32 ();
                i --;
            } while (i);
            j--;
            if (j == 0) break;
            pos += StepY ();
            p1  = pos + 2 * StepX_32 ();
            i   = (x2 - x1) / 4;
            do {
                PMemset_32 (p1, c1);
                p1 += StepX_32 ();
                PMemset_32 (p1, c1);
                p1 += 3 * StepX_32 ();
                i --;
            } while (i);
            pos += StepY ();
            j--;
        } while (j);
    }
}

void CScreen::PutEdge (unsigned x1, unsigned y1, unsigned x2, unsigned y2, unsigned color) {
    unsigned i, pos;
    if (locksurf == NULL)     error_hook ();
    if (x1 == x2 || y1 == y2) error_hook ();
    if (x1 > winxsize) x1 = 0; else if (x2 >= winxsize) x2 = winxsize - 1;
    if (y1 > winysize) y1 = 0; else if (y2 >= winysize) y2 = winysize - 1;
    color = GetColor (color);
    x2 ++;
    if (winbpp == 2) {
        pos = (x1 + 1) * StepX_16 () + y1 * StepY ();
        i = x2 - x1;
        if (i > 2) i -= 2;
        do {
            PMemset_16 (pos, color);
            pos += StepX_16 ();
            i --;
        } while (i);
        pos = (x1 + 1) * StepX_16 () + y2 * StepY ();
        i = x2 - x1;
        if (i > 2) i -= 2;
        do {
            PMemset_16 (pos, color);
            pos += StepX_16 ();
            i --;
        } while (i);
        pos = x1 * StepX_16 () + (y1 + 1) * StepY ();
        i = y2 - y1;
        if (i > 1) i -= 1;
        do {
            PMemset_16 (pos, color);
            pos += StepY ();
            i --;
        } while (i);
        pos = (x2 - 1) * StepX_16 () + (y1 + 1) * StepY ();
        i = y2 - y1;
        if (i > 1) i -= 1;
        do {
            PMemset_16 (pos, color);
            pos += StepY ();
            i --;
        } while (i);
    } else {
        pos = (x1 + 1) * StepX_32 () + y1 * StepY ();
        i = x2 - x1 - 2;
        do {
            PMemset_32 (pos, color);
            pos += StepX_32 ();
            i --;
        } while (i);
        pos = (x1 + 1) * StepX_32 () + y2 * StepY ();
        i = x2 - x1 - 2;
        do {
            PMemset_32 (pos, color);
            pos += StepX_32 ();
            i --;
        } while (i);
        pos = x1 * StepX_32 () + (y1 + 1) * StepY ();
        i = y2 - y1 - 2;
        do {
            PMemset_32 (pos, color);
            pos += StepY ();
            i --;
        } while (i);
        pos = x2 * StepX_32 () + (y1 + 1) * StepY ();
        i = y2 - y1 - 2;
        do {
            PMemset_32 (pos, color);
            pos += StepY ();
            i --;
        } while (i);
    }
}
#else
void CScreen::PutGray (int x1, int y1, int x2, int y2, unsigned) {
    if (locksurf == NULL) error_hook ();
    int i, j;
    for (j=y1; j<y2; j++) for (i=x1; i<x2; i++) {
        putpixel (locksurf, i, j, getpixel (locksurf, i, j) & 0x5555);
    }
}
#endif

/******************************* Sprite class ********************************/

#ifndef USE_ALLEGRO
#ifndef LINUX

bool CSprite::Create (unsigned xsz, unsigned ysz, char *data, bool vidmem) {
    HDC              hdc;
    BITMAPINFOHEADER bmiHeader;
    DDBLTFX          bltfx;
    if (this == NULL) return false;
    xsize = xsz;
    ysize = ysz;
    if (surface == NULL) {
        if (Screen.CreateSurface (xsize, ysize, &surface, vidmem) == false) return false;
    }
    if (data != NULL) {
        if (surface->GetDC (&hdc) != DD_OK) {
            TRACE0 ("Sprite:Load: getdc fails\n");
            return false;
        }
        memset (&bmiHeader, 0, sizeof (BITMAPINFOHEADER));
        bmiHeader.biSize        = sizeof (BITMAPINFOHEADER);
        bmiHeader.biPlanes      = 1;
        bmiHeader.biBitCount    = 24;
        bmiHeader.biCompression = BI_RGB;
        bmiHeader.biWidth       = xsize;
        bmiHeader.biHeight      = ysize;
        StretchDIBits (hdc, 0, 0, xsize, ysize, 0, 0,
            xsize, ysize, data, (LPBITMAPINFO) &bmiHeader, DIB_RGB_COLORS, SRCCOPY);
        surface->ReleaseDC (hdc);
    } else {
        bltfx.dwSize      = sizeof (DDBLTFX);
        bltfx.dwFillColor = 0;
        surface->Blt (NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);
    }
    return true;
}

void CSprite::Destroy (void) {
    if (bmpbuf) {
        delete [] bmpbuf;
        bmpbuf = NULL;
    }
    if (surface) {
        surface->Release ();
        surface = NULL;
    }
}

#else

bool CSprite::Create (unsigned xsz, unsigned ysz, char *data, bool vidmem) {
    unsigned     x;
    int          y;
    const Uint8* dest;
    Uint8        R, G, B;
    Uint32       color32;
    if (this == NULL) return false;

    xsize = xsz;
    ysize = ysz;

    if (!surface && !Screen.CreateSurface (xsize, ysize, &surface, true)) {
        theApp.DebugMessage ("Creating sprite buffer", true);
        theApp.DebugMessage (SDL_GetError (), true);
        return false;
    }
    if (data != NULL) {
        SDL_LockSurface (surface);
        for (y = ysize-1; y >= 0; --y) {
            dest = (Uint8*) surface->pixels + y * surface->pitch;
            for (x = 0; x < xsize; ++x) {
                B = *data++;
                G = *data++;
                R = *data++;
                color32 = SDL_MapRGB (surface->format, R, G, B);
                if (Screen.winbpp == 2)
                     *(Uint16*)(dest + 2 * x) = (Uint16) color32;
                else *(Uint32*)(dest + 4 * x) = color32;
            }
        }
        SDL_UnlockSurface (surface);
    } else {
        SDL_FillRect (surface, 0, 0);
    }
    return true;
}

void CSprite::Destroy (void) {
    if (bmpbuf) {
        delete [] bmpbuf;
        bmpbuf = NULL;
    }
    if (surface && surface != Screen.screen) {
        SDL_FreeSurface (surface);
        surface = NULL;
    }
}

#endif
#else

bool CSprite::Create (unsigned xsz, unsigned ysz, char *data, bool) {
    unsigned      x;
    int           y;
    unsigned char R, G, B;
    if (this == NULL) return false;

    xsize = xsz;
    ysize = ysz;

    if (!surface) {
        surface = create_bitmap (xsize, ysize);
        if (surface == NULL) {
            theApp.DebugMessage ("Creating sprite buffer", true);
            theApp.DebugMessage (allegro_error, true);
            return false;
        }
    }
    if (data != NULL) {
        acquire_bitmap (surface);
        for (y = ysize-1; y >= 0; --y) {
            for (x = 0; x < xsize; ++x) {
                B = *data++;
                G = *data++;
                R = *data++;
                if ((R|G|B) == 0) { R = 0xff; B = 0xff; }
                putpixel (surface, x, y, makecol16 (R, G, B));
            }
        }
        release_bitmap (surface);
    } else {
        rectfill (surface, 0, 0, xsize, ysize, 0);
    }
    return true;
}

void CSprite::Destroy (void) {
    if (bmpbuf) {
        delete [] bmpbuf;
        bmpbuf = NULL;
    }
    if (surface) {
        destroy_bitmap (surface);
        surface = NULL;
    }
}

#endif


CSprite::CSprite (void) {
    memset (this, 0, sizeof (CSprite));
}

CSprite::~CSprite (void) {
    Destroy ();
}

bool CSprite::Load (const char *name) {
    bool ret;

    if (image != 0xffff) {
        #ifdef _DEBUG
            unsigned size,
                     offs,
                     i;
            FILE     *file;
            char     name1 [0x1ff];
            sprintf (name1, "%s", name);
            for (i=0; name1[i]; i++) if (name1[i] == '\\') name1[i] = SLASHCHAR;
            name = name1;
            file = fopen (name, "rb");
            if (file == NULL) return false;
            fseek (file,   2, SEEK_SET);
            fread (&size,  4, 1, file);
            fseek (file,   4, SEEK_CUR);
            fread (&offs,  4, 1, file);
            fseek (file,   4, SEEK_CUR);
            fread (&xsize, 4, 1, file);
            fread (&ysize, 4, 1, file);
            fseek (file, offs, SEEK_SET);
            size -= offs;
            bmpbuf = new char [size];
            if (bmpbuf == NULL) {
                theApp.runlevel = Run_MemError;
                fclose (file);
                return false;
            }
            fread (bmpbuf, size, 1, file);
            if (ferror (file)) {
                theApp.runlevel = Run_FileError;
                fclose (file);
                return false;
            }
            fclose (file);
        #else
            if (name);
            unsigned i = MediaRef[Screen.offset_bmp + image];
            if (i == 0) {
                xsize  = 100;
                ysize  = 100;
                bmpbuf = new char (xsize * ysize * 3);
                if (bmpbuf == NULL) return false;
            } else if (i & ALTLIB) {
                if (theApp.AltLib == NULL) {
                    xsize  = 100;
                    ysize  = 100;
                    bmpbuf = new char (xsize * ysize * 3);
                    if (bmpbuf == NULL) return false;
                } else {
                    fseek (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                    fread (&xsize, 4, 1, theApp.AltLib);
                    fread (&ysize, 4, 1, theApp.AltLib);
                    bmpbuf = pack.ExpandToRam (theApp.AltLib);
                    if (bmpbuf == NULL) return false;
                    if (ferror (theApp.AltLib)) {
                        delete [] bmpbuf;
                        bmpbuf = NULL;
                        return false;
                    }
                }
            } else {
                fseek (theApp.MediaLib, i, SEEK_SET);
                fread (&xsize, 4, 1, theApp.MediaLib);
                fread (&ysize, 4, 1, theApp.MediaLib);
                bmpbuf = pack.ExpandToRam (theApp.MediaLib);
                if (bmpbuf == NULL) return false;
                if (ferror (theApp.MediaLib)) {
                    delete [] bmpbuf;
                    bmpbuf = NULL;
                    return false;
                }
            }
        #endif
    }
    if (sprfunc  != NULL) sprfunc (this);
    ret = Create (xsize, ysize, bmpbuf, true);
    if (postfunc != NULL) postfunc (this);
    if (bmpbuf) {
        delete [] bmpbuf;
        bmpbuf = NULL;
    }
    return ret;
}

CSprite* CSprite::AddToList (IDirectDrawSurface *spr) {
    if (surface) {
        if (next == NULL) {
            next = new CSprite;
            if (next == NULL) {
                theApp.runlevel = Run_MemError;
                return NULL;
            }
        }
        return next->AddToList (spr);
    }
    surface = spr;
    return this;
}

CSprite* CScreen::LoadSprite (unsigned sprnum, SFUNC *func, SFUNC *pfunc) {
    CSprite *sprite = &sprlist;
    theApp.DebugMessage ("Sprite buffer");
    while (sprite->surface) {
        if (sprite->next == NULL) {
            sprite->next = new CSprite;
            if (sprite->next == NULL) {
                theApp.runlevel = Run_MemError;
                return NULL;
            }
        }
        sprite = sprite->next;
    }
    sprite->image    = sprnum;
    sprite->sprfunc  = func;
    sprite->postfunc = pfunc;
    theApp.HandleProgBar ();
    if (sprite->Load (StrTable[Str_Bitmaps + sprite->image])) return sprite;
    return NULL;
}

void CSprite::BlitTiled (int tx, int ty, int sx, int sy, int ax, int ay, int dx, int dy) {
    int x, y;
    if (this == NULL) return;
    for (x = tx; x < tx + ax - dx; x += dx) {
        for (y = ty; y < ty + ay - dy; y += dy)
            Blit (x, y, sx, sy, dx, dy);
        Blit (x, y, sx, sy, dx, ty + ay - y);
    }
    for (y = ty; y < ty + ay - dy; y += dy)
        Blit (x, y, sx, sy, tx + ax - x, dy);
    Blit (x, y, sx, sy, tx + ax - x, ty + ay - y);
}



/****************************** Animation class ******************************/

CAnimation::CAnimation (void) {
    memset (this, 0, sizeof (CAnimation));
}

#ifndef NO_ANIM

#define ColorSchFunc(x,y) \
static void Spr_##x (CSprite *spr) { \
    unsigned i, j, back; \
    back = (spr->bmpbuf[0] * 0x10000) + (spr->bmpbuf[1] * 0x100) + spr->bmpbuf[2]; \
    for (i=0; i<spr->xsize * spr->ysize * 3; i+=3) { \
        j = (spr->bmpbuf[i] * 0x10000) + (spr->bmpbuf[i+1] * 0x100) + spr->bmpbuf[i+2]; \
        if (j != back) { \
            y            \
        }                \
    }                    \
}

ColorSchFunc (ColorSch1,
              spr->bmpbuf[i + 1] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 0] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 2] =  j        & 0xff; )
ColorSchFunc (ColorSch2,
              spr->bmpbuf[i + 0] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 2] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 1] =  j        & 0xff; )
ColorSchFunc (ColorSch3,
              spr->bmpbuf[i + 2] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 0] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 1] =  j        & 0xff; )
ColorSchFunc (ColorSch4,
              spr->bmpbuf[i + 1] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 2] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 0] =  j        & 0xff; )
ColorSchFunc (ColorSch5,
              spr->bmpbuf[i + 2] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 1] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 0] =  j        & 0xff; )
ColorSchFunc (ColorSch6,
              j = ((j >> 16) + (j >> 8) + j) / 3;
              spr->bmpbuf[i + 0] = j;
              spr->bmpbuf[i + 1] = j;
              spr->bmpbuf[i + 2] = j; )
ColorSchFunc (ColorSch7,
              spr->bmpbuf[i + 0] = (j >> 16) & 0xff;
              spr->bmpbuf[i + 1] = 0;
              spr->bmpbuf[i + 2] = 0; )
ColorSchFunc (ColorSch8,
              spr->bmpbuf[i + 0] = 0;
              spr->bmpbuf[i + 1] = (j >>  8) & 0xff;
              spr->bmpbuf[i + 2] = 0; )
ColorSchFunc (ColorSch9,
              spr->bmpbuf[i + 0] = 0;
              spr->bmpbuf[i + 1] = 0;
              spr->bmpbuf[i + 2] =  j        & 0xff; )

static void Spr_Transparent (CSprite *spr) {
    unsigned i, j, back;
    back = (spr->bmpbuf[0] * 0x10000) + (spr->bmpbuf[1] * 0x100) + spr->bmpbuf[2];
    if (back == 0) return;
    for (i=0; i<spr->xsize * spr->ysize * 3; i+=3) {
        j = (spr->bmpbuf[i] * 0x10000) + (spr->bmpbuf[i+1] * 0x100) + spr->bmpbuf[i+2];
        if (j == back) {
            spr->bmpbuf[i + 0] = 0;
            spr->bmpbuf[i + 1] = 0;
            spr->bmpbuf[i + 2] = 0;
        } else if ((j & 0xf8fcf8) == 0) {
            spr->bmpbuf[i + 0] = 4;
            spr->bmpbuf[i + 1] = 4;
            spr->bmpbuf[i + 2] = 4;
        }
    }
}

static void Spr_TrimEdges (CSprite *spr) {
    unsigned i, x, y, dx, dy, c;
    char     *b1,
             *b2;
    
    if (spr == NULL) return;
    b2 = spr->bmpbuf;
    if (b2 == NULL) return;

    dx = spr->xsize / 2;
    dy = spr->ysize / 2;
    for (i=0; i<spr->xsize * spr->ysize * 3; i+=3) {
        c = (spr->bmpbuf[i] * 0x10000) + (spr->bmpbuf[i+1] * 0x100) + spr->bmpbuf[i+2];
        if (c) {
            x = (i / 3) % spr->xsize;
            y = (i / 3) / spr->xsize;
            if (x < dx) dx = x;
            if (y < dy) dy = y;
            if (spr->xsize - x - 1 < dx) dx = spr->xsize - x - 1;
            if (spr->ysize - y - 1 < dy) dy = spr->ysize - y - 1;
            if (dx == 0 && dy == 0) return;
        }
    }
    dx &= 0xfffe;
    // y trimming from below is not good. Dependent on 3/4ths etc
    i = spr->xsize - dx - dx;
    b1 = new char [i * (spr->ysize - dy - dy) * 3];
    if (b1 == NULL) {
        theApp.runlevel = Run_MemError;
        return;
    }
    for (y=0; y<spr->ysize - dy - dy; y++) for (x=0; x<i; x++) {
        b1[(x + i * y) * 3    ] = b2[(x + dx + spr->xsize * (y + dy)) * 3];
        b1[(x + i * y) * 3 + 1] = b2[(x + dx + spr->xsize * (y + dy)) * 3 + 1];
        b1[(x + i * y) * 3 + 2] = b2[(x + dx + spr->xsize * (y + dy)) * 3 + 2];
    }
    spr->xsize  -= dx * 2;
    spr->ysize  -= dy * 2;
    spr->bmpbuf  = b1;
    delete [] b2;
}

static bool PurgeAnims (void) {
    unsigned i, j, k, l;
    for (i=0; i<MAX_ANITYPE; i++) {
        if (Anims[i].loaded && Anims[i].refcount == 0) {
            l = 0;
            for (j=0; j<6 * 8; j++) if (Anims[i].startframe[j] != 0xffff) {
                for (k=0; k<Anims[i].numframes[j]; k++) {
                    Screen.animsprites[Anims[i].startframe[j] + k].Destroy ();
                    l ++;
                }
            }
            for (j=Anims[i].startframe[0] + l; j<MAX_ANIM; j++) {
                memcpy (&Screen.animsprites[j - l], &Screen.animsprites[j], sizeof (CSprite));
            }
            for (j=l; j>0; j--)
                memset (&Screen.animsprites[MAX_ANIM - j], 0, sizeof (CSprite));
            for (j=0; j<MAX_ANITYPE; j++)
                for (k=0; k<6 * 8; k++)
                    if (Anims[j].startframe[k] > Anims[i].startframe[0]
                    &&  Anims[j].startframe[k] != 0xffff)
                        Anims[j].startframe[k] -= l;
            Screen.nextsprite -= l;
            memset (&Anims[i], 0, sizeof (CAnimation));
        }
    }
    if (Screen.nextsprite >= MAX_ANIM) {
        theApp.runlevel = Run_MemError;
        return false;
    }
    return true;
}

unsigned CAnimation::GetFrame (unsigned state, unsigned dir) {
    unsigned dir1;
    if (loaded == 1) {
        dir1 = refcount;
        refcount = 0;
        PurgeAnims ();
        refcount = dir1;
        Load (this - Anims, false);
    } else if (loaded != 2) {
        Load (this - Anims, false);
    }
    if (state < Str_A_Idle || state > Str_A_Death) state = Str_A_Idle;
    if (state >= Str_A_Death) {
        dir    = state - Str_A_Death;
        dir1   = dir;
        state  = Str_A_Death - Str_A_Idle;
    } else {
        state -= Str_A_Idle;
        dir   &= 7;
        dir1   = dir & 6;
    }
    if (numframes[state * 8 + dir])  return state * 8 + dir;
    if (numframes[state * 8 + dir1]) return state * 8 + dir1;
    if (state == Str_A_Run - Str_A_Idle || state == Str_A_Attack - Str_A_Idle) {
        state = Str_A_Walk - Str_A_Idle;
        if (numframes[state * 8 + dir])  return state * 8 + dir;
        if (numframes[state * 8 + dir1]) return state * 8 + dir1;
    }
    if (numframes[dir])  return dir;
    if (numframes[dir1]) return dir1;
    if (numframes[(Str_A_Walk - Str_A_Idle) * 8 + dir]) return (Str_A_Walk - Str_A_Idle) * 8 + dir;
    return 0;
}

void CAnimation::Display (int x, int y, unsigned pose, unsigned frame) {
    unsigned sprnum;
    if (this == NULL) return;
    sprnum = startframe[pose];
    if (sprnum == 0xffff) return;
    if (numframes[pose]) {
        if (pose >= 16 && pose < 24 && (flags & Ani_Atk_Rewind)) {
            frame %= numframes[pose] * 2;
            if (frame >= numframes[pose]) frame = (numframes[pose] * 2) - frame - 2;
            sprnum += frame;
        } else {
            sprnum += (frame % numframes[pose]);
        }
    }
    int xs = Screen.animsprites[sprnum].xsize,
        ys = Screen.animsprites[sprnum].ysize,
        dx = 0,
        dy = 0;
    x -= xs / 2;
    if      (flags & Ani_3_4ths) y -= (ys * 3) / 4;
    else if (flags & Ani_Center) y -= ys / 2;
    else                         y -= ys;
    if (x < 0) {
        xs += x;
        if (xs < 0) return;
        dx -= x;
        x   = 0;
    } else if (x + xs > (signed) Screen.winxsize) {
        if (x >= (signed) Screen.winxsize) return;
        xs = Screen.winxsize - x;
    }
    if (y < 0) {
        ys += y;
        if (ys < 0) return;
        dy -= y;
        y   = 0;
    } else if (y + ys > (signed) Screen.winysize) {
        if (y >= (signed) Screen.winysize) return;
        ys = Screen.winysize - y;
    }
    Screen.animsprites[sprnum].BlitTr (x, y, dx, dy, xs, ys);
}

void CAnimation::DisplayThumb (int x, int y) {
    unsigned sprnum = 0xffff, i;
    if (this == NULL) return;
    if (loaded == 0) {
        Load (this - Anims, true);
    }
    for (i=0; i<sizeof (startframe) / sizeof (startframe[0]); i++) {
        if (startframe[i] != 0xffff) {
            sprnum = startframe[i];
            break;
        }
    }
    if (sprnum == 0xffff) return;
    int xs = Screen.animsprites[sprnum].xsize,
        ys = Screen.animsprites[sprnum].ysize,
        dx = 0,
        dy = 0;
    x -= xs / 2;
    if      (flags & Ani_3_4ths) y -= (ys * 3) / 4;
    else if (flags & Ani_Center) y -= ys / 2;
    else                         y -= ys;
    if (x < 0) {
        xs += x;
        if (xs < 0) return;
        dx -= x;
        x   = 0;
    } else if (x + xs > (signed) Screen.winxsize) {
        if (x >= (signed) Screen.winxsize) return;
        xs = Screen.winxsize - x;
    }
    if (y < 0) {
        ys += y;
        if (ys < 0) return;
        dy -= y;
        y   = 0;
    } else if (y + ys > (signed) Screen.winysize) {
        if (y >= (signed) Screen.winysize) return;
        ys = Screen.winysize - y;
    }
    Screen.animsprites[sprnum].BlitTr (x, y, dx, dy, xs, ys);
}

void CAnimation::Load (unsigned atp, bool thumb) {
    unsigned i, j, k;
    CSprite  *spr;
    char     buf[255];
    FILE     *file;
    bool     sf = false;
    #ifdef _DEBUG
        theApp.ChangeDirectory (theApp.HomeDir);
        theApp.ChangeDirectory (StrTable[Str_AnimDir]);
        sprintf (buf, "%s.spr", StrTable[anitypes[atp].number]);
        if (pack.ReadBufferPure (buf)) {
            if (theApp.ChangeDirectory (StrTable[anitypes[atp].number]) == false) return;
        } else {
            for (i=0; i<6 * 8; i++) numframes[i] = pack.ReadB ();
            sf = true;
        }
    #else
        i = MediaRef[Screen.offset_spr + anitypes[atp].number - Str_AnimDir - 1];
        if (i == 0) return;
        if (i & ALTLIB) {
            if (theApp.AltLib == NULL) return;
            fseek (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
            i = pack.ReadBuffer (theApp.AltLib);
        } else {
            fseek (theApp.MediaLib, i, SEEK_SET);
            i = pack.ReadBuffer ();
        }
        if (i) {
            theApp.runlevel = Run_FileError;
            return;
        }
        for (i=0; i<6 * 8; i++) numframes[i] = pack.ReadB ();
        sf = true;
    #endif
    for (i=Str_A_Idle; i<=Str_A_Death; i++) {
        for (j=0; j<8; j++) {
            if (i < Str_A_Death)
                 startframe [((i - Str_A_Idle) * 8) + j] = Screen.nextsprite;
            else startframe [((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death] = Screen.nextsprite;
            k = 0;
            if (sf && numframes[((i - Str_A_Idle) * 8) + j] == 0) continue;
            while (1) {
                if (sf == 0) {
                    if (i == Str_A_Idle && j == 0) {
                        if (loaded == 1) break;
                    }
                    if (i < Str_A_Death) {
                        if (k <= 9) sprintf (buf, StrTable[i], StrTable[Str_A_Dir_0 + j], k + '0');
                        else        sprintf (buf, StrTable[i], StrTable[Str_A_Dir_0 + j], k + 'A' - 10);
                    } else {
                        if (k <= 9) sprintf (buf, StrTable[i], k + '0');
                        else        sprintf (buf, StrTable[i], k + 'A' - 10);
                    }
                    file = fopen (buf, "rb");
                    if (file == NULL) break;
                    fclose (file);
                }
                if (Screen.nextsprite >= MAX_ANIM) {
                    if (PurgeAnims () == false) return;
                }
                spr = &Screen.animsprites[Screen.nextsprite];
                spr->image = 0;// some value
                switch (anitypes[atp].scheme) {
                    case 1:  spr->sprfunc = Spr_ColorSch1; break;
                    case 2:  spr->sprfunc = Spr_ColorSch2; break;
                    case 3:  spr->sprfunc = Spr_ColorSch3; break;
                    case 4:  spr->sprfunc = Spr_ColorSch4; break;
                    case 5:  spr->sprfunc = Spr_ColorSch5; break;
                    case 6:  spr->sprfunc = Spr_ColorSch6; break;
                    case 7:  spr->sprfunc = Spr_ColorSch7; break;
                    case 8:  spr->sprfunc = Spr_ColorSch8; break;
                    case 9:  spr->sprfunc = Spr_ColorSch9; break;
                    default: spr->sprfunc = NULL;          break;
                }
                if (sf) {
                    spr->xsize = pack.ReadD ();
                    spr->ysize = pack.ReadD ();
                    spr->bmpbuf = new char [spr->xsize * spr->ysize * 3];
                    if (spr->bmpbuf == NULL) {
                        theApp.runlevel = Run_MemError;
                        return;
                    }
                    pack.Read (spr->bmpbuf, spr->xsize * spr->ysize * 3);
                    if (spr->sprfunc != NULL) spr->sprfunc (spr);
                    spr->Create (spr->xsize, spr->ysize, spr->bmpbuf, true);
                    if (spr->bmpbuf) {
                        delete [] spr->bmpbuf;
                        spr->bmpbuf = NULL;
                    }
                    Screen.nextsprite ++;
                    k++;
                    if (i < Str_A_Death) {
                        if (k >= numframes[((i - Str_A_Idle) * 8) + j]) break;
                    } else {
                        if (k >= numframes[((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death]) break;
                    }
                } else {
                    if (spr->Load (buf) == false) break;
                    if (i < Str_A_Death)
                         numframes [((i - Str_A_Idle) * 8) + j] ++;
                    else numframes [((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death] ++;
                    Screen.nextsprite ++;
                    k++;
                    if (k >= 29) break;
                }
                if (thumb) {
                    i = Str_A_Death + 1;
                    j = 99;
                    break;
                }
            }
            if (j == 99) break;
            if (sf && i < Str_A_Death) {
                if (numframes  [((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death] == 0)
                    startframe [((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death] = 0xffff;
            } else {
                if (numframes  [((i - Str_A_Idle) * 8) + j] == 0)
                    startframe [((i - Str_A_Idle) * 8) + j] = 0xffff;
            }
            if (sf == false && i >= Str_A_Death) break;
        }
    }
    if (theApp.MediaLib == NULL) theApp.ChangeDirectory (theApp.HomeDir);
    flags = anitypes[atp].flags;
    if (thumb) {
        loaded = 1;
        for (i=0; i<6*8; i++) if (numframes[i] == 0)
            startframe[i] = 0xffff;
    } else loaded = 2;
}

#ifdef _DEBUG

void CScreen::MakeSprFile (const char *dirname) {
    unsigned i, j, k;
    unsigned size, offs, xsize, ysize;
    char     buf[255],
             frames[6 * 8];
    BYTE     *bmpbuf;
    FILE     *file, *out;
    if (theApp.ChangeDirectory (theApp.HomeDir) == false) return;
    if (theApp.ChangeDirectory (RESDIR "anim")  == false) return;
    sprintf (buf, "%s.spr", dirname);
    out = fopen (buf, "wb");
    if (out == NULL) return;
    theApp.ChangeDirectory (dirname);
    for (i=0; i<6 * 8; i++) {
        fputc (0, out);
        frames[i] = 0;
    }
    for (i=Str_A_Idle; i<=Str_A_Death; i++) {
        for (j=0; j<8; j++) {
            for (k=0; k<29; k++) {
                if (i >= Str_A_Death) {
                    if (k <= 9) sprintf (buf, StrTable[i], k + '0');
                    else        sprintf (buf, StrTable[i], k + 'A' - 10);
                } else {
                    if (k <= 9) sprintf (buf, StrTable[i], StrTable[Str_A_Dir_0 + j], k + '0');
                    else        sprintf (buf, StrTable[i], StrTable[Str_A_Dir_0 + j], k + 'A' - 10);
                }
                file = fopen (buf, "rb");
                if (file == NULL) break;
                fseek (file,   2, SEEK_SET);
                fread (&size,  4, 1, file);
                fseek (file,   4, SEEK_CUR);
                fread (&offs,  4, 1, file);
                fseek (file,   4, SEEK_CUR);
                fread (&xsize, 4, 1, file);
                fread (&ysize, 4, 1, file);
                fseek (file, offs, SEEK_SET);
                size -= offs;
                bmpbuf = new BYTE [size];
                if (bmpbuf == NULL) {
                    theApp.runlevel = Run_MemError;
                    fclose (file);
                    return;
                }
                fread (bmpbuf, size, 1, file);
                if (ferror (file)) {
                    theApp.runlevel = Run_FileError;
                    fclose (file);
                    return;
                }
                fclose (file);
                fwrite (&xsize, 4, 1, out);
                fwrite (&ysize, 4, 1, out);
                fwrite (bmpbuf, size, 1, out);
                if (i >= Str_A_Death)
                     frames [((Str_A_Death - Str_A_Idle) * 8) + i - Str_A_Death] ++;
                else frames [((i - Str_A_Idle) * 8) + j] ++;
                delete [] bmpbuf;
            }
            if (i >= Str_A_Death) break;
        }
    }
    fseek  (out, 0, SEEK_SET);
    fwrite (frames, sizeof (frames), 1, out);
    fclose (out);
}

void CScreen::ConvertSprites (unsigned num) {
    CSprite  sp1;
    FILE     *file;
    unsigned size,
             offs,
             i, j, k,
             atp;
    char     fname[32];

    atp = num;
    theApp.ChangeDirectory (theApp.HomeDir);
    theApp.ChangeDirectory (StrTable[Str_AnimDir]);
    theApp.ChangeDirectory (StrTable[anitypes[atp].number]);
    for (i=Str_A_Idle; i<=Str_A_Death; i++) {
        for (j=0; j<8; j++) {
            for (k=0; k<29; k++) {
                if (i < Str_A_Death) {
                    if (k <= 9) sprintf (fname, StrTable[i], StrTable[Str_A_Dir_0 + j], k + '0');
                    else        sprintf (fname, StrTable[i], StrTable[Str_A_Dir_0 + j], k + 'A' - 10);
                } else {
                    if (k <= 9) sprintf (fname, StrTable[i], k + '0');
                    else        sprintf (fname, StrTable[i], k + 'A' - 10);
                }
                memset (&sp1, 0, sizeof (CSprite));
                file = fopen (fname, "rb");
                if (file == NULL) continue;
                fseek (file,   2, SEEK_SET);
                fread (&size,  4, 1, file);
                fseek (file,   4, SEEK_CUR);
                fread (&offs,  4, 1, file);
                fseek (file,   4, SEEK_CUR);
                fread (&sp1.xsize, 4, 1, file);
                fread (&sp1.ysize, 4, 1, file);
                fseek (file, offs, SEEK_SET);
                size -= offs;
                sp1.bmpbuf = new char [size];
                if (sp1.bmpbuf == NULL) {
                    theApp.runlevel = Run_MemError;
                    fclose (file);
                    return;
                }
                fread (sp1.bmpbuf, size, 1, file);
                if (ferror (file)) {
                    theApp.runlevel = Run_FileError;
                    fclose (file);
                    return;
                }
                fclose                 (file);
                Spr_Transparent        (&sp1);
                Spr_TrimEdges          (&sp1);
                theApp.ChangeDirectory ("New", true);
                //SaveBitmap             (&sp1, fname);
                theApp.ChangeDirectory ("..");
                sp1.Destroy            ();
                TRACE1                 ("%s\n", fname);
            }
        }
    }
}

#else

void CScreen::MakeSprFile    (const char *) {}
void CScreen::ConvertSprites (unsigned)     {}

#endif
#else

static bool PurgeAnims (void) { return false; }

#endif



/****************************** Animation list *******************************/

#ifndef NO_ANIM

void CScreen::AnimStart (void) {
    if (animlist != NULL) {
        if (junkfirst == NULL) junkfirst      = animlist;
        else                   junklast->next = animlist;
        for (junklast = animlist; junklast->next != NULL; junklast = junklast->next);
        animlist = NULL;
    }
}

void CScreen::AnimShow (void) {
    CAnimList *tmp;
    for (tmp = animlist; tmp != NULL; tmp = tmp->next) {
        tmp->anim->Display (tmp->x, tmp->y, tmp->pose, tmp->frame);
    }
}

void CScreen::AnimAdd (CAnimation* ani, unsigned x, unsigned y, unsigned pose, unsigned frame) {
    CAnimList *tmp,
              *t2 = NULL,
              *nw;
    if (junkfirst) {
        nw        = junkfirst;
        junkfirst = junkfirst->next;
    } else {
        nw = new CAnimList;
        if (nw == NULL) {
            theApp.runlevel = Run_MemError;
            return;
        }
    }
    nw->anim  = ani;
    nw->x     = x;
    nw->y     = y;
    nw->pose  = pose;
    nw->frame = frame;
    if (animlist == NULL) {
        animlist = nw;
        nw->next = NULL;
    } else if (animlist->y > y) {
        nw->next = animlist;
        animlist = nw;
    } else {
        for (tmp = animlist; tmp != NULL; tmp = tmp->next) {
            if (tmp->y > y) break;
            t2 = tmp;
        }
        nw->next = t2->next;
        t2->next = nw;
    }
}

#else

void CScreen::AnimStart (void) {}
void CScreen::AnimShow  (void) {}
void CScreen::AnimAdd   (CAnimation*, unsigned, unsigned, unsigned, unsigned) {}

#endif



/******************************* JPEG display ********************************/

bool CScreen::LoadJpeg (unsigned num, bool vidmem, unsigned xsz, unsigned ysz) {
    unsigned i, j, k, l, j1;
    BYTE     *dataBuf,
             *scaledBuf;
    ULONG    rowlen;
    PBYTE    buffer [1];

    if (num >= last_jpeg) return false;
    if (theApp.MediaLib == NULL) {
        if (jpeg_cache[0] == 0xffff) return false;
        jpeg_cache[0] = 0xffff;
        jpeg          = jpegbuf[0];
    } else {
        if (num == jpeg_cache[0]) {
            jpeg = jpegbuf[0];
            return true;
        }
        for (i=1; i<MAX_JBUF; i++) {
            if (num == jpeg_cache[i]) {
                if (jpegbuf[i]->xsize == winxsize && jpegbuf[i]->ysize == winysize) {
                    jpeg = jpegbuf[0];
                    jpegbuf[i]->BlitTo (0, 0, 0, 0, jpegbuf[i]->xsize, jpegbuf[i]->ysize, jpegbuf[0]);
                    jpeg_cache[0] = num;
                } else {
                    jpeg = jpegbuf[i];
                }
                jpeg_merge1 = num;
                jpeg_merge2 = num;
                return true;
            }
        }
        if (jpeg_cycle == 0) jpeg_cycle = 1;
        jpeg_cache[jpeg_cycle] = num;

        i = MediaRef[offset_jpeg + num];
        if (i) while (1) {
            if (i & ALTLIB) {
                if (theApp.AltLib == NULL) break;
                fseek          (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                jpeg_stdio_src (&cinfo, theApp.AltLib);
            } else {
                fseek          (theApp.MediaLib, i, SEEK_SET);
                jpeg_stdio_src (&cinfo, theApp.MediaLib);
            }
            jpeg_read_header (&cinfo, TRUE);
            cinfo.do_block_smoothing  = FALSE;
            cinfo.do_fancy_upsampling = FALSE;
            cinfo.dct_method          = JDCT_FASTEST;
            jpeg_start_decompress (&cinfo);

            rowlen  = cinfo.output_width * 3;
            dataBuf = new BYTE [rowlen * cinfo.output_height];
            if (dataBuf == NULL) {
                theApp.runlevel = Run_MemError;
                return false;
            }
            buffer [0] = dataBuf + (rowlen * cinfo.output_height);
            while (cinfo.output_scanline < cinfo.output_height) {
                buffer[0] -= rowlen;
                jpeg_read_scanlines (&cinfo, buffer, 1);
            }
            jpeg_finish_decompress (&cinfo);

            if (xsz != 0 && ysz != 0 && (xsz != cinfo.output_width || ysz != cinfo.output_height)) {
                scaledBuf = new BYTE [xsz * ysz * 3];
                for (j=0; j<ysz; j++) {
                    j1 = ysz - 1 - j;
                    l  = cinfo.output_height - 1 - ((j * cinfo.output_height) / ysz);
                    for (i=0; i<xsz; i++) {
                        k = (i * cinfo.output_width) / xsz;
                        scaledBuf[ (i + xsz * j1) * 3]      = dataBuf[ (k + cinfo.output_width * l) * 3];
                        scaledBuf[((i + xsz * j1) * 3) + 1] = dataBuf[((k + cinfo.output_width * l) * 3) + 1];
                        scaledBuf[((i + xsz * j1) * 3) + 2] = dataBuf[((k + cinfo.output_width * l) * 3) + 2];
                    }
                }
                i = jpegbuf[jpeg_cycle]->Create (xsz, ysz, (char*) scaledBuf, vidmem);
                delete [] scaledBuf;
            } else {
                i = jpegbuf[jpeg_cycle]->Create (cinfo.output_width, cinfo.output_height, (char*) dataBuf, vidmem);
            }
            if (jpegbuf[jpeg_cycle]->xsize == winxsize && jpegbuf[jpeg_cycle]->ysize == winysize) {
                jpeg = jpegbuf[0];
                jpeg_cache[0] = num;
                jpegbuf[jpeg_cycle]->BlitTo (0, 0, 0, 0, jpegbuf[jpeg_cycle]->xsize, jpegbuf[jpeg_cycle]->ysize, jpegbuf[0]);
                jpeg_merge1 = num;
                jpeg_merge2 = num;
            } else {
                jpeg = jpegbuf[jpeg_cycle];
            }
            jpeg_cycle = (jpeg_cycle + 1) % MAX_JBUF;
            delete [] dataBuf;
            return i != 0;
        }
    }

    dataBuf = new BYTE [winxsize * winysize * 3];
    if (dataBuf == NULL) {
        theApp.runlevel = Run_MemError;
        return false;
    }
    jpeg = jpegbuf[jpeg_cycle];
    memset (dataBuf, 0x5f, winxsize * winysize * 3);
    i = jpegbuf[jpeg_cycle]->Create (winxsize, winysize, (char*) dataBuf, false);
    jpeg_cycle = (jpeg_cycle + 1) % MAX_JBUF;
    delete [] dataBuf;
    return i != 0;
}

unsigned CScreen::MergeJpeg (unsigned num, unsigned xpos, unsigned ypos, unsigned xsrc, unsigned ysrc, unsigned xsz, unsigned ysz) {
    unsigned i;
    BYTE     *dataBuf;
    ULONG    rowlen;
    PBYTE    buffer [1];

    if (num >= last_jpeg) return false;
    jpeg = jpegbuf[0];
    if (theApp.MediaLib == NULL) {
        if (jpeg_cache[0] == 0xffff) return false;
        jpeg_cache[0] = 0xffff;
    } else {
        jpeg_cache[0] = num;
        if (xpos < winxsize / 2) {
            if (num == jpeg_merge1) return true;
            jpeg_merge1 = num;
        } else {
            if (num == jpeg_merge2) return true;
            jpeg_merge2 = num;
        }
        for (i=1; i<MAX_JBUF; i++)
            if (num == jpeg_cache[i]) break;
        if (i == MAX_JBUF) {
            if (jpeg_cycle == 0) jpeg_cycle = 1;
            jpeg_cache[jpeg_cycle] = num;
            i = MediaRef[offset_jpeg + num];
            if (i == 0) {
                i = jpegbuf[jpeg_cycle]->Create (winxsize, winysize, NULL, false);
            } else do {
                if (i & ALTLIB) {
                    if (theApp.AltLib == NULL) {
                        i = jpegbuf[jpeg_cycle]->Create (winxsize, winysize, NULL, false);
                        break;
                    }
                    fseek          (theApp.AltLib, i ^ ALTLIB, SEEK_SET);
                    jpeg_stdio_src (&cinfo, theApp.AltLib);
                } else {
                    fseek          (theApp.MediaLib, i, SEEK_SET);
                    jpeg_stdio_src (&cinfo, theApp.MediaLib);
                }
                jpeg_read_header (&cinfo, TRUE);
                cinfo.do_block_smoothing  = FALSE;
                cinfo.do_fancy_upsampling = FALSE;
                cinfo.dct_method          = JDCT_FASTEST;
                jpeg_start_decompress (&cinfo);

                rowlen  = cinfo.output_width * 3;
                dataBuf = new BYTE [rowlen * cinfo.output_height];
                if (dataBuf == NULL) {
                    theApp.runlevel = Run_MemError;
                    return false;
                }
                buffer [0] = dataBuf + (rowlen * cinfo.output_height);
                while (cinfo.output_scanline < cinfo.output_height) {
                    buffer[0] -= rowlen;
                    jpeg_read_scanlines (&cinfo, buffer, 1);
                }
                jpeg_finish_decompress (&cinfo);
                i = jpegbuf[jpeg_cycle]->Create (cinfo.output_width, cinfo.output_height, (char*) dataBuf, true);
                delete [] dataBuf;
            } while (0);
            if (i == false) return false;
            i = jpeg_cycle;
            jpeg_cycle = (jpeg_cycle + 1) % MAX_JBUF;
        }
        jpegbuf[i]->BlitTo (xpos, ypos, xsrc, ysrc, xsz, ysz, jpeg);
        return true;
    }
    dataBuf = new BYTE [winxsize * winysize * 3];
    if (dataBuf == NULL) {
        theApp.runlevel = Run_MemError;
        return false;
    }
    jpeg = jpegbuf[jpeg_cycle];
    memset (dataBuf, 0x5f, winxsize * winysize * 3);
    i = jpegbuf[jpeg_cycle]->Create (winxsize, winysize, (char*) dataBuf, false);
    jpeg_cycle = (jpeg_cycle + 1) % MAX_JBUF;
    delete [] dataBuf;
    return i != 0;
}
